# -*- coding: utf-8 -*-

import os, sys, io, zipfile, re
import xml.parsers.expat
# import plistlib, xml.parsers.expat
from operator import attrgetter, itemgetter

Python2 = sys.version_info[0] == 2
if Python2:
	import ConfigParser as configparser
	from plistlib import readPlist as readPlistFile
	from plistlib import readPlistFromString as readPlistStream
else:
	import configparser
	from plistlib import load as readPlistFile
	from plistlib import loads as readPlistStream
	
from platform import system as platform_system
curr_system = platform_system()
platformIsLinux = curr_system == 'Linux'
platformIsWindows = curr_system == 'Windows'
platformIsMacOS = curr_system not in ['Linux', 'Windows']

#####################################
## toggle all before mk

# DEBUG = False
DEBUG = True

import pdb
if Python2:
	import traceback
	class stackprinter(object):
		@staticmethod
		def show(*args, **kwargs):
			traceback.print_exc(*args)
else:
	import stackprinter

#####################################

# LEFT OFF: 

# SearchOnlyOxpFolders is only printed, not checked (ie. has no effect!)
# - must ensure it does not exclude oolite.app

# trap for weapon_range = 7500; in subentities, type = ball_turret; and change to 7200

# configparser

# sys.args for dragging file onto

# write output when run for side effects
# = part of overall argparse

# getting tons of shipdata errors: model = ... ref's files not present
#  - problem is oxp's in effectdata.plist that are not loaded
#      => will require the user to run collect_shipdata
# 	 - add instr's to suppress: mk copy of logcontrol.plist (Resouces/Config -> AddOns)
#       and change: shipData.load.error = no;

# OPTIONS
								
MaxVersions = 5					# number of previous versions to retain
IncludeLaunchFolder = True		# include the current working folder in INCLUDE_FOLDERS
# IncludeLaunchFolder = False ## tmp for dev 
SearchOnlyOxpFolders = True		# if False, will gather data from all folders it crawls

RemoveFlasherSubEnts = True     # to reduce output size (& since telescope collects light over time...  \_0_/ )
LogFoldersSearched = True       # log all folders that are scanned by walker
logFoldersProcessed = True		# log folder where INPUT_FN where found and loaded
LogOxzSearched = True			# log all folders that are scanned by walker
logOxzProcessed = True			# log folder where INPUT_FN where found and loaded
LogUnquotedDash = False         # reporting of unquoted keys/values containing '-'s (there are lots!)
LogMissingSemiColon = False      # reporting of missing ';'s after lists & dictionaries
LogDuplicateKeys = False         # reporting of keys duplicated across different oxp's
LogDifferentSource = True        # report when referenced file has different oriigin
LogDupsWithCollation = False    # include keys loaded from COLLATE_FILE as duplicates; only useful for debugging
								# and progressive collection; LogOnlyDifferentDups is forced True to prevent
								# ALL keys being dups!
LogOnlyDifferentDups = True     # limit logging of duplicates to those that differ vs. logging all
AuditUniformTextures = False     # compare uniform indices to textures list to find missing textures (
								# are no longer output, so must add to 'Keys_to_output' in addition to setting this True

OutputSourceAsComment = False    # output source file path of data to COLLATE_FILE as comment
OutputDifferentSource = True     # output as comment when referenced file has different oriigin
OutputDupsAsComments = False    # keys with duplicate values output to COLLATE_FILE as comments
OutputDupsSource = False        # include filename of source when OutputDupsAsComments
OutputOnlyDifferentDups = True  # limit dup reporting to those that differ vs. output all

RetainSourceComments = False    # preserve comments in source (vs trashing them all)
ConsolidateComments = False     # preserve all comments from all sources
OutputCommentSource = False     # output source file path of comments included via ConsolidateComments
RetainDBComments = False        # preserve comments in COLLATE_FILE read in @ start (careful, else multiply like rabbits!)
								# - current use has COLLATE_FILE getting read before any source files, so its comments will duplicate
								#   (or worse, if source files re-read); this option indended for different usage of this script

INCLUDE_FOLDERS = [ 
	'AddOns', 
	'ManagedAddOns', 
	'oolite.app\\Resources',
] 
# limit folders to these and their sub-folders (.oxp folders are limited to 1 folder deep)
# if [], all sub-folders in launch folder will be searched
## NB: for resolving duplicates, folder w/ lower index has precedence
##     the launch folder (cwd) is assumed to preceed these, so if you don't want its duplicates
##     to have precedence, include it in INCLUDE_FOLDERS
# a multi-level spec. (eg. oolite.app\Resources) will further limit included folders, so in our eg.,
#   only the Resouces folder under the oolite.app folder is included, no other Resouces folder
# INCLUDE_FOLDERS = []

EXCLUDE_FOLDERS = [ 'nppBackup', '_orig oxz\'s', 'tmp', '_editing' ] # , '_swap' , 'edited in AddOns'
# exclude any folder that is a child of these
# if [], no folder will be excluded
# EXCLUDE_FOLDERS =[] 

# keys to output in .plist; [] will output all
Keys_to_output = [ # keys for effectdata.plist files; removed 'script', 'script_info' as not interchangable
	'beacon', 
	'is_break_pattern', 
	'is_external_dependency', # "is_external_dependency" = yes; suppress errors; ?add if not present
	'is_template', 
	'like_effect', 
	'like_ship', # 'like_ship' added to get swapped for 'like_effect'; both required as script also used to process existing effects data
	'materials', 
	'model', 
	'scanner_display_color1', 
	'scanner_display_color2',
	# 'shaders', 
	'smooth', 
	'subentities' 
]
# Keys_to_output = []

# keys are renamed before output  
Keys_to_rename = { 'like_ship': 'like_effect' } # convert shipdata to effectdata requires renaming keys; ?only one
# Keys_to_rename = {}

# keys to insert when a (trigger) key is detected
# dict of dict w/ each entry being triggerKey: { insertKey: insertValue }
Keys_to_insert = { 'like_effect': { 'is_external_dependency': 'yes' },
	# add 'is_external_dependency' to suppress oolite errors for ref's to files in missing oxp's
				 # { '': '' },
}    
# Keys_to_insert = {}  

# subkeys to insert when a (trigger) key is detected and key is not already present
# dict of dict w/ each entry being triggerKey: { insertKey: insertValue,... }
Subkeys_to_insert_if_empty = { 
	'materials': { 'illumination_map': 'telescope-illumination.png',
				   'illumination_modulate_color': 'blackColor' }
}
# Subkeys_to_insert_if_empty = {}  

# these keys are output on a single line
# subentities are a special case, as there is a legacy format of simple strings that are not compacted
Keys_to_compact = [ 'scanner_display_color1', 'scanner_display_color2', 
					'materials', 'shaders', 'subentities' ]
# Keys_to_compact = []                      

# these subkeys are output on a single line
Subkeys_to_compact = [ 'textures', 'uniforms' ]
# Subkeys_to_compact = []                      

# these keys are logged but not output
Keys_to_log_only = [ # visual effect properties; removed 'script', 'scriptInfo' as not interchangable
	'beaconCode', 
	'beaconLabel', 
	'dataKey', 
	'hullHeatLevel', 
	'isBreakPattern',
	'scaleX', 
	'scaleY', 
	'scaleZ', 
	'scannerDisplayColor1', 
	'scannerDisplayColor2',
	'shaderFloat1', 
	'shaderFloat2',
	'shaderInt1', 
	'shaderInt2', 
	'shaderVector1', 
	'shaderVector2', 
	'subEntities' 
]
# Keys_to_log_only = []

Entities_to_ignore = [ # ignored for telescope as outputted as static data (see TELESCOPE_EFFECTDATA)
	"telescope-blue_flag", "telescope-blue_largeball", 	"telescope-blue_ball", 	"telescope-blue_marker", 
	"telescope-blue_smallmarker", "telescope-blue_tinymarker", "telescope-blue_dotmarker", 
	"telescope-brown_flag", "telescope-brown_largeball", "telescope-brown_ball", "telescope-brown_marker", 
	"telescope-brown_smallmarker", "telescope-brown_tinymarker", "telescope-brown_dotmarker", 
	"telescope-cyan_flag", "telescope-cyan_largeball", "telescope-cyan_ball", "telescope-cyan_marker", 
	"telescope-cyan_smallmarker", "telescope-cyan_tinymarker", "telescope-cyan_dotmarker", 
	"telescope-gray_flag", "telescope-gray_largeball", "telescope-gray_ball", "telescope-gray_marker", 
	"telescope-gray_smallmarker", "telescope-gray_tinymarker", "telescope-gray_dotmarker", 
	"telescope-green_flag","telescope-green_largeball", "telescope-green_ball", "telescope-green_marker", 
	"telescope-green_smallmarker", "telescope-green_tinymarker", "telescope-green_dotmarker", 
	"telescope-lightgray_flag", "telescope-lightgray_largeball", "telescope-lightgray_ball", "telescope-lightgray_marker", 
	"telescope-lightgray_smallmarker", "telescope-lightgray_tinymarker", "telescope-lightgray_dotmarker", 
	"telescope-lightgray_moon", "telescope-lightgray_moonflag", 
	"telescope-orange_flag", "telescope-orange_largeball", "telescope-orange_ball", "telescope-orange_marker", 
	"telescope-orange_smallmarker", "telescope-orange_tinymarker", "telescope-orange_dotmarker", 
	"telescope-pink_flag", "telescope-pink_largeball", "telescope-pink_ball", "telescope-pink_marker", 
	"telescope-pink_smallmarker", "telescope-pink_tinymarker", "telescope-pink_dotmarker", 
	"telescope-purple_flag", "telescope-purple_largeball", "telescope-purple_ball", "telescope-purple_marker", 
	"telescope-purple_smallmarker", "telescope-purple_tinymarker", "telescope-purple_dotmarker", 
	"telescope-red_flag", "telescope-red_largeball", "telescope-red_ball", "telescope-red_marker", 
	"telescope-red_smallmarker", "telescope-red_tinymarker", "telescope-red_dotmarker", 
	"telescope-white_flag", "telescope-white_largeball", "telescope-white_ball", "telescope-white_marker", 
	"telescope-white_smallmarker", "telescope-white_tinymarker", "telescope-white_dotmarker", 
	"telescope-yellow_flag", "telescope-yellow_largeball", "telescope-yellow_ball", "telescope-yellow_marker", 
	"telescope-yellow_smallmarker", "telescope-yellow_tinymarker", "telescope-yellow_dotmarker", 
	"telescope-shadow", "telescopemarker","telescope-ring", "telescope-sniper", 
	"telescope-blue_ml", "telescope-blue_mlf", "telescope-blue_mlt", "telescope-blue2_ml", "telescope-blue2_mlf", "telescope-blue2_mlt", 
	"telescope-brown_ml", "telescope-brown_mlf", "telescope-brown_mlt", "telescope-brown2_ml", "telescope-brown2_mlf", "telescope-brown2_mlt", 
	"telescope-cyan_ml", "telescope-cyan_mlf", "telescope-cyan_mlt", "telescope-cyan2_ml", "telescope-cyan2_mlf", "telescope-cyan2_mlt", 
	"telescope-gray_ml", "telescope-gray_mlf", "telescope-gray_mlt", "telescope-gray2_ml", "telescope-gray2_mlf", "telescope-gray2_mlt", 
	"telescope-green_ml", "telescope-green_mlf", "telescope-green_mlt", "telescope-green2_ml", "telescope-green2_mlf", "telescope-green2_mlt", 
	"telescope-lightgray_ml", "telescope-lightgray_mlf", "telescope-lightgray_mlt", "telescope-lightgray2_ml", "telescope-lightgray2_mlf", "telescope-lightgray2_mlt", 
	"telescope-orange_ml", "telescope-orange_mlf", "telescope-orange_mlt", "telescope-orange2_ml", "telescope-orange2_mlf", "telescope-orange2_mlt", 
	"telescope-pink_ml", "telescope-pink_mlf", "telescope-pink_mlt", "telescope-pink2_ml", "telescope-pink2_mlf", "telescope-pink2_mlt", 
	"telescope-purple_ml", "telescope-purple_mlf", "telescope-purple_mlt", "telescope-purple2_ml", "telescope-purple2_mlf", "telescope-purple2_mlt", 
	"telescope-red_ml", "telescope-red_mlf", "telescope-red_mlt", "telescope-red2_ml", "telescope-red2_mlf", "telescope-red2_mlt", 
	"telescope-white_ml", "telescope-white_mlf", "telescope-white_mlt", "telescope-white2_ml", "telescope-white2_mlf", "telescope-white2_mlt", 
	"telescope-yellow_ml", "telescope-yellow_mlf", "telescope-yellow_mlt", "telescope-yellow2_ml", "telescope-yellow2_mlf", "telescope-yellow2_mlt" 
]

OXP_FOLDER_EXT = '.oxp'	 # ext of folders searched (must be LOWERCASE!)
ZIPPEDFILES = [ '.oxz' ] # ext of zip files searched (must be LOWERCASE!)
						 # to incl .zip files use: [ '.oxz', '.zip' ]
						 # if [], all zip type files, regardless of .ext, will be checked

COLLATE_FILE = 'telescope_effectdata'   ## is read in first if present, so data accumulates; 
										## NB: if a duplicate definition found, INCLUDE_FOLDERS's ordering is used to select
COLLATE_EXT = '.plist'
COLLATE_FN = COLLATE_FILE + COLLATE_EXT
# set to None to run for side effects (error checking but not uniform validation)
# COLLATE_FN = None

INPUT_FILE = 'shipdata'
INPUT_EXT = '.plist'
INPUT_FN = (INPUT_FILE + INPUT_EXT).lower()

LOG_FN = 'collect_shipdata.log'
LOG_MESSAGES = True
LOG_WARNINGS = True
LOG_ERRORS = True
LOG_LINELEN = 100
MAX_FOLDER_DEPTH = 20

TABSPACE = 2
OPENINGS = '([{'
CLOSINGS = ')]}'
ENCLOSURES = OPENINGS + CLOSINGS
QUOTES = '\'"`'   
INPUT_FILE_MARKER = '\n\n//{} {} {}'
OUTPUT_FILE_HEADER = '{\n'
OUTPUT_FILE_TAIL = '}\n'
TRUEVALUES = [ 'true', 'yes', 'on' ]
FALSEVALUES = [ 'false', 'no', 'off' ]
BOOLEANS = TRUEVALUES + FALSEVALUES

TRANS_CHARS = '"\';()[]{}\n\f\r\t\v'
# used in str.translate calls in _str_minimize()
if Python2:	#  'alphabet code'.translate(None, 'abc')
	from string import maketrans
	MakeSparse = maketrans( TRANS_CHARS, ' ' * len( TRANS_CHARS ) ) 
else:		#  'alphabet code'.translate(''.maketrans({'a': '', 'b':'', 'c':''}))
	MakeSparse = ''.maketrans( TRANS_CHARS, ' ' * len( TRANS_CHARS ) ) 
	
ORIGIN_MARKER = 'sDpL:' # part of re, so careful what you set it to!
COMMENT_MARKER = '_cMT_'    # reserved key name for comments 
DUP_KEY_PREFIX = '__dupKey_'

# GLOBAL VARIABLES

Launch_dir = None       # full path of current working directory
Launch_folder = None    # its basename, for possible inclusion in Included_dirs
Included_dirs = None    # working copy of INCLUDE_FOLDERS, as Launch_folder *may* be inserted
Loading_data = False    # flag for when processing previously generated effectdata
Data_origin = None      # filespec of ship definition
Existing_size = 0       # size of effects already in (in COLLATE_FILE)
Input_file_count = 0    # # of files processed by tree crawler
Input_size = 0          # size of all input INPUT_FILE's
Output_size = 0         # size of resultant data added to COLLATE_FN
CurrentFile = None      # filename for error msgs
EffectsFile = None      # path for existing compilation, if present
Logfile = None
Files_logged = []       # files which have had an error or warning (so only output once)
Registered_ents = dict()
EntsInEffectsdata = 0
SourceFileNames= []

TELESCOPE_EFFECTDATA = '''\n
	"telescope-blue_flag" = { model = "telescope-marker.dat"; scanner_display_color1 = blueColor; };
	"telescope-blue_largeball" = { model = "telescope-marker.dat"; scanner_display_color1 = blueColor;
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 1000; color = "0.75 0.75 1";});};
	"telescope-blue_ball" = { model = "telescope-marker.dat"; scanner_display_color1 = blueColor;
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 800; color = "0.75 0.75 1";});};
	"telescope-blue_marker" = { model = "telescope-marker.dat"; scanner_display_color1 = blueColor;
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 600; color = "0.5 0.5 1";});};
	"telescope-blue_smallmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = "0 0 0.7"; //farther ship
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 400; color = "0.5 0.5 1";});};
	"telescope-blue_tinymarker" = { model = "telescope-marker.dat"; scanner_display_color1 = "0 0 0.7"; //under 30t
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 250; color = "0.5 0.5 1";});};
	"telescope-blue_dotmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = "0 0 0.7"; //very far
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 100; color = "0.5 0.5 1";});};
	\n
	"telescope-brown_flag" = { model = "telescope-marker.dat"; scanner_display_color1 = "0.45 0.3 0.15"; };
	"telescope-brown_largeball" = { model = "telescope-marker.dat"; scanner_display_color1 = brownColor; //0.6, 0.4, 0.2 RGB
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 1000; color = brownColor;});};
	"telescope-brown_ball" = { model = "telescope-marker.dat"; scanner_display_color1 = brownColor; //close to the dark orange
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 800; color = brownColor;});};
	"telescope-brown_marker" = { model = "telescope-marker.dat"; scanner_display_color1 = "0.6 0.4 0.2"; //farther ship
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 500; color = brownColor;});};
	"telescope-brown_smallmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = "0.45 0.3 0.15";//darkest brown
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 300; color = brownColor;});};
	"telescope-brown_tinymarker" = { model = "telescope-marker.dat"; scanner_display_color1 = "0.45 0.3 0.15";//under 30t
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 200; color = brownColor;});};
	"telescope-brown_dotmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = "0.45 0.3 0.15"; //very far
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 150; color = brownColor;});};
	\n
	"telescope-cyan_flag" = { model = "telescope-marker.dat"; scanner_display_color1 = cyanColor; };
	"telescope-cyan_largeball" = { model = "telescope-marker.dat"; scanner_display_color1 = cyanColor; // 0, 1, 1 RGB
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 800; color = cyanColor;});};
	"telescope-cyan_ball" = { model = "telescope-marker.dat"; scanner_display_color1 = cyanColor; // 0, 1, 1 RGB
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 600; color = cyanColor;});};
	"telescope-cyan_marker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0, 0.5, 0.5);
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 400; color = cyanColor;});};
	"telescope-cyan_smallmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0, 0.4, 0.4); //farther ship
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 300; color = cyanColor;});};
	"telescope-cyan_tinymarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0, 0.4, 0.4); //under 30t
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 200; color = cyanColor;});};
	"telescope-cyan_dotmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0, 0.4, 0.4); //very far
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 100; color = cyanColor;});};
	\n
	"telescope-gray_flag" = { model = "telescope-marker.dat"; scanner_display_color1 = darkGrayColor; };
	"telescope-gray_largeball" = { model = "telescope-marker.dat"; scanner_display_color1 = darkGrayColor; // 0.5 white
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 1000; color = darkGrayColor;});};
	"telescope-gray_ball" = { model = "telescope-marker.dat"; scanner_display_color1 = darkGrayColor; // 0.5 white
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 800; color = darkGrayColor;});};
	"telescope-gray_marker" = { model = "telescope-marker.dat"; scanner_display_color1 = darkGrayColor; // 0.333 white
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 500; color = darkGrayColor;});};
	"telescope-gray_smallmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = darkGrayColor; //farther ship
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 300; color = darkGrayColor;});};
	"telescope-gray_tinymarker" = { model = "telescope-marker.dat"; scanner_display_color1 = darkGrayColor; //under 30t
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 200; color = darkGrayColor;});};
	"telescope-gray_dotmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = darkGrayColor; //very far
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 100; color = darkGrayColor;});};
	\n
	"telescope-green_flag" = { model = "telescope-marker.dat"; scanner_display_color1 = greenColor; };
	"telescope-green_largeball" = { model = "telescope-marker.dat"; scanner_display_color1 = greenColor;
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 1000; color = "0 0.5 0";});};
	"telescope-green_ball" = { model = "telescope-marker.dat"; scanner_display_color1 = greenColor;
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 800; color = "0 0.5 0";});};
	"telescope-green_marker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0, 0.8, 0);
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 600; color = "0 0.5 0";});};
	"telescope-green_smallmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0, 0.6, 0); //farther buoy
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 300; color = "0 0.5 0";});};
	"telescope-green_tinymarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0, 0.4, 0); //under 30t
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 200; color = "0 0.5 0";});};
	"telescope-green_dotmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0, 0.4, 0); //very far
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 100; color = "0 0.5 0";});};
	\n
	"telescope-lightgray_flag" = { model = "telescope-marker.dat"; scanner_display_color1 = grayColor; }; //Planet
	"telescope-lightgray_largeball" = { model = "telescope-marker.dat"; scanner_display_color1 = grayColor; // 0.5 white
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 1000; color = grayColor;});};
	"telescope-lightgray_ball" = { model = "telescope-marker.dat"; scanner_display_color1 = grayColor; // 0.5 white
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 800; color = grayColor;});};
	"telescope-lightgray_marker" = { model = "telescope-marker.dat"; scanner_display_color1 = grayColor;
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 500; color = grayColor;});};
	"telescope-lightgray_smallmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = grayColor; //far ship
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 300; color = grayColor;});};
	"telescope-lightgray_tinymarker" = { model = "telescope-marker.dat"; scanner_display_color1 = grayColor; //under 30t
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 200; color = grayColor;});};
	"telescope-lightgray_dotmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = grayColor; //very far
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 100; color = grayColor;});};
	\n
	"telescope-lightgray_moon" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.4, 0.4, 0.4); //Moon
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 50; color = grayColor;});};
	"telescope-lightgray_moonflag" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.4, 0.4, 0.4);};
	\n
	"telescope-orange_flag" = { model = "telescope-marker.dat"; scanner_display_color1 = "0.6 0.3 0"; };
	"telescope-orange_largeball" = { model = "telescope-marker.dat"; scanner_display_color1 = orangeColor; //1.0, 0.5, 0.0 RGB
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 1000; color = orangeColor;});};
	"telescope-orange_ball" = { model = "telescope-marker.dat"; scanner_display_color1 = orangeColor; // 1.0, 0.5, 0.0 RGB
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 800; color = orangeColor;});};
	"telescope-orange_marker" = { model = "telescope-marker.dat"; scanner_display_color1 = "0.9 0.45 0"; //a bit darker orange
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 500; color = orangeColor;});};
	"telescope-orange_smallmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = "0.6 0.3 0"; //dark orange
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 300; color = orangeColor;});};
	"telescope-orange_tinymarker" = { model = "telescope-marker.dat"; scanner_display_color1 = "0.6 0.3 0"; //under 30t
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 200; color = orangeColor;});};
	"telescope-orange_dotmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = "0.6 0.3 0"; //very far
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 100; color = orangeColor;});};
	\n
	"telescope-pink_flag" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.98, 0.69, 0.75); };
	"telescope-pink_largeball" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.98, 0.69, 0.75);
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 800; color = "0.98 0.69 0.75";});};
	"telescope-pink_ball" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.98, 0.69, 0.75);
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 600; color = "0.98 0.69 0.75";});};
	"telescope-pink_marker" = { model = "telescope-marker.dat"; scanner_display_color1 = (210, 135, 150);
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 400; color = "0.98 0.69 0.75";});};
	"telescope-pink_smallmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (210, 135, 150); //farther ship
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 300; color = "0.98 0.69 0.75";});};
	"telescope-pink_tinymarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (210, 135, 150); //under 30t
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 200; color = "0.98 0.69 0.75";});};
	"telescope-pink_dotmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (210, 135, 150); //very far
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 100; color = "0.98 0.69 0.75";});};
	\n
	"telescope-purple_flag" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.25, 0, 0.25); };
	"telescope-purple_largeball" = { model = "telescope-marker.dat"; scanner_display_color1 = purpleColor;//0.5, 0.0, 0.5 RGB
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 1000; color = "0.75 0 0.75";});};
	"telescope-purple_ball" = { model = "telescope-marker.dat"; scanner_display_color1 = purpleColor;
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 800; color = "0.75 0 0.75";});};
	"telescope-purple_marker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.25, 0, 0.25);
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 600; color = "0.75 0 0.75";});};
	"telescope-purple_smallmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.2, 0, 0.2); //farther ship
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 400; color = "0.75 0 0.75";});};
	"telescope-purple_tinymarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.2, 0, 0.2); //under 30t
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 300; color = "0.75 0 0.75";});};
	"telescope-purple_dotmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.2, 0, 0.2); //very far
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 150; color = "0.75 0 0.75";});};
	\n
	"telescope-red_flag" = { model = "telescope-marker.dat"; scanner_display_color1 = redColor; };
	"telescope-red_largeball" = { model = "telescope-marker.dat"; scanner_display_color1 = redColor;
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 1000; color = redColor;});};
	"telescope-red_ball" = { model = "telescope-marker.dat"; scanner_display_color1 = redColor;
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 800; color = redColor;});};
	"telescope-red_marker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.8, 0, 0);
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 600; color = redColor;});};
	"telescope-red_smallmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.6, 0, 0); //farther ship
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 400; color = redColor;});};
	"telescope-red_tinymarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.6, 0, 0); //under 30t
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 300; color = redColor;});};
	"telescope-red_dotmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.6, 0, 0); //very far
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 100; color = redColor;});};
	\n
	"telescope-white_flag" = { model = "telescope-marker.dat"; scanner_display_color1 = whiteColor; };
	"telescope-white_largeball" = { model = "telescope-marker.dat"; scanner_display_color1 = whiteColor; //small cargo, etc.
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 800; color = "0.9 0.9 0.9";});};
	"telescope-white_ball" = { model = "telescope-marker.dat"; scanner_display_color1 = whiteColor; //small cargo, etc.
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 600; color = "0.9 0.9 0.9";});};
	"telescope-white_marker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.9, 0.9, 0.9);//almost white
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 400; color = "0.9 0.9 0.9";});};
	"telescope-white_smallmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.9, 0.9, 0.9);
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 300; color = "0.9 0.9 0.9";});};
	"telescope-white_tinymarker" = { model = "telescope-marker.dat"; scanner_display_color1 = whiteColor;
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 150; color = whiteColor;});};
	"telescope-white_dotmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = whiteColor; //sun
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 100; color = whiteColor;});};
	\n
	"telescope-yellow_flag" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.6, 0.6, 0); };
	"telescope-yellow_largeball" = { model = "telescope-marker.dat"; scanner_display_color1 = yellowColor; //1.0, 1.0, 0.0 RGB
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 1000; color = yellowColor;});};
	"telescope-yellow_ball" = { model = "telescope-marker.dat"; scanner_display_color1 = yellowColor; // 1.0, 1.0, 0.0 RGB
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 800; color = yellowColor;});};
	"telescope-yellow_marker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.8, 0.8, 0);
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 600; color = yellowColor;});};
	"telescope-yellow_smallmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.6, 0.6, 0); //farther ship
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 300; color = yellowColor;});};
	"telescope-yellow_tinymarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.6, 0.6, 0); //under 30t
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 200; color = yellowColor;});};
	"telescope-yellow_dotmarker" = { model = "telescope-marker.dat"; scanner_display_color1 = (0.6, 0.6, 0); //very far
		subentities = ( { type = flasher; position = (0, 0, 0); frequency = 0; size = 100; color = yellowColor;});};
	\n
	"telescope-blue_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-blue.png"; emission_map = "telescope-blue.png";};};};
	"telescope-blue_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-blue.png"; emission_map = "telescope-blue.png";};};};
	"telescope-blue_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-blue.png"; emission_map = "telescope-blue.png";};};};
	"telescope-blue2_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-blue2.png"; emission_map = "telescope-blue.png";};};};
	"telescope-blue2_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-blue2.png"; emission_map = "telescope-blue.png";};};};
	"telescope-blue2_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-blue2.png"; emission_map = "telescope-blue.png";};};};
	\n
	"telescope-brown_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-brown.png"; emission_map = "telescope-brown.png";};};};
	"telescope-brown_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-brown.png"; emission_map = "telescope-brown.png";};};};
	"telescope-brown_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-brown.png"; emission_map = "telescope-brown.png";};};};
	"telescope-brown2_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-brown2.png"; emission_map = "telescope-brown.png";};};};
	"telescope-brown2_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-brown2.png"; emission_map = "telescope-brown.png";};};};
	"telescope-brown2_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-brown2.png"; emission_map = "telescope-brown.png";};};};
	\n
	"telescope-cyan_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-cyan.png"; emission_map = "telescope-cyan.png";};};};
	"telescope-cyan_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-cyan.png"; emission_map = "telescope-cyan.png";};};};
	"telescope-cyan_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-cyan.png"; emission_map = "telescope-cyan.png";};};};
	"telescope-cyan2_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-cyan2.png"; emission_map = "telescope-cyan.png";};};};
	"telescope-cyan2_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-cyan2.png"; emission_map = "telescope-cyan.png";};};};
	"telescope-cyan2_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-cyan2.png"; emission_map = "telescope-cyan.png";};};};
	\n
	"telescope-gray_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-gray.png"; emission_map = "telescope-gray.png";};};};
	"telescope-gray_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-gray.png"; emission_map = "telescope-gray.png";};};};
	"telescope-gray_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-gray.png"; emission_map = "telescope-gray.png";};};};
	"telescope-gray2_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-gray2.png"; emission_map = "telescope-gray.png";};};};
	"telescope-gray2_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-gray2.png"; emission_map = "telescope-gray.png";};};};
	"telescope-gray2_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-gray2.png"; emission_map = "telescope-gray.png";};};};
	\n
	"telescope-green_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { shininess = 90; "telescope-ring.png" = { diffuse_map = "telescope-green.png"; emission_map = "telescope-green.png";};};};
	"telescope-green_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { shininess = 90; "telescope-ring.png" = { diffuse_map = "telescope-green.png"; emission_map = "telescope-green.png";};};};
	"telescope-green_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { shininess = 90; "telescope-ring.png" = { diffuse_map = "telescope-green.png"; emission_map = "telescope-green.png";};};};
	"telescope-green2_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { shininess = 90; "telescope-ring.png" = { diffuse_map = "telescope-green2.png"; emission_map = "telescope-green.png";};};};
	"telescope-green2_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { shininess = 90; "telescope-ring.png" = { diffuse_map = "telescope-green2.png"; emission_map = "telescope-green.png";};};};
	"telescope-green2_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { shininess = 90; "telescope-ring.png" = { diffuse_map = "telescope-green2.png"; emission_map = "telescope-green.png";};};};
	\n
	"telescope-lightgray_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-lightgray.png"; emission_map = "telescope-lightgray.png";};};};
	"telescope-lightgray_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-lightgray.png"; emission_map = "telescope-lightgray.png";};};};
	"telescope-lightgray_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-lightgray.png"; emission_map = "telescope-lightgray.png";};};};
	"telescope-lightgray2_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-lightgray2.png"; emission_map = "telescope-lightgray.png";};};};
	"telescope-lightgray2_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-lightgray2.png"; emission_map = "telescope-lightgray.png";};};};
	"telescope-lightgray2_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-lightgray2.png"; emission_map = "telescope-lightgray.png";};};};
	\n
	"telescope-orange_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-orange.png"; emission_map = "telescope-orange.png";};};};
	"telescope-orange_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-orange.png"; emission_map = "telescope-orange.png";};};};
	"telescope-orange_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-orange.png"; emission_map = "telescope-orange.png";};};};
	"telescope-orange2_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-orange2.png"; emission_map = "telescope-orange.png";};};};
	"telescope-orange2_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-orange2.png"; emission_map = "telescope-orange.png";};};};
	"telescope-orange2_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-orange2.png"; emission_map = "telescope-orange.png";};};};
	\n
	"telescope-pink_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-pink.png"; emission_map = "telescope-pink.png";};};};
	"telescope-pink_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-pink.png"; emission_map = "telescope-pink.png";};};};
	"telescope-pink_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-pink.png"; emission_map = "telescope-pink.png";};};};
	"telescope-pink2_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-pink2.png"; emission_map = "telescope-pink.png";};};};
	"telescope-pink2_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-pink2.png"; emission_map = "telescope-pink.png";};};};
	"telescope-pink2_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-pink2.png"; emission_map = "telescope-pink.png";};};};
	\n
	"telescope-purple_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { shininess = 90; "telescope-ring.png" = { diffuse_map = "telescope-purple.png"; emission_map = "telescope-purple.png";};};};
	"telescope-purple_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { shininess = 90; "telescope-ring.png" = { diffuse_map = "telescope-purple.png"; emission_map = "telescope-purple.png";};};};
	"telescope-purple_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { shininess = 90; "telescope-ring.png" = { diffuse_map = "telescope-purple.png"; emission_map = "telescope-purple.png";};};};
	"telescope-purple2_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { shininess = 90; "telescope-ring.png" = { diffuse_map = "telescope-purple2.png"; emission_map = "telescope-purple.png";};};};
	"telescope-purple2_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { shininess = 90; "telescope-ring.png" = { diffuse_map = "telescope-purple2.png"; emission_map = "telescope-purple.png";};};};
	"telescope-purple2_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { shininess = 90; "telescope-ring.png" = { diffuse_map = "telescope-purple2.png"; emission_map = "telescope-purple.png";};};};
	\n
	"telescope-red_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-red.png"; emission_map = "telescope-red.png";};};};
	"telescope-red_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-red.png"; emission_map = "telescope-red.png";};};};
	"telescope-red_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-red.png"; emission_map = "telescope-red.png";};};};
	"telescope-red2_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-red2.png"; emission_map = "telescope-red.png";};};};
	"telescope-red2_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-red2.png"; emission_map = "telescope-red.png";};};};
	"telescope-red2_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-red2.png"; emission_map = "telescope-red.png";};};};
	\n
	"telescope-white_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-white.png"; emission_map = "telescope-white.png";};};};
	"telescope-white_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-white.png"; emission_map = "telescope-white.png";};};};
	"telescope-white_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-white.png"; emission_map = "telescope-white.png";};};};
	"telescope-white2_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-white2.png"; emission_map = "telescope-white.png";};};};
	"telescope-white2_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-white2.png"; emission_map = "telescope-white.png";};};};
	"telescope-white2_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-white2.png"; emission_map = "telescope-white.png";};};};
	\n
	"telescope-yellow_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-yellow.png"; emission_map = "telescope-yellow.png";};};};
	"telescope-yellow_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-yellow.png"; emission_map = "telescope-yellow.png";};};};
	"telescope-yellow_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-yellow.png"; emission_map = "telescope-yellow.png";};};};
	"telescope-yellow2_ml" = { model = "telescope-masslock.dat"; smooth = yes; //masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-yellow2.png"; emission_map = "telescope-yellow.png";};};};
	"telescope-yellow2_mlf" = { model = "telescope-masslockfar.dat"; smooth = yes; //far masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-yellow2.png"; emission_map = "telescope-yellow.png";};};};
	"telescope-yellow2_mlt" = { model = "telescope-masslockthin.dat"; smooth = yes; //thin masslock border
		materials = { "telescope-ring.png" = { diffuse_map = "telescope-yellow2.png"; emission_map = "telescope-yellow.png";};};};
	
	"telescope-shadow" = { model = "telescope-marker.dat"; scanner_display_color1 = lightGrayColor; };// 0.667 white
	"telescopemarker" = { model = "telescope-marker.dat"; scanner_display_color1 = lightGrayColor; scanner_display_color2 = lightGrayColor;};
	"telescope-ring" = { model = "telescope-ring.dat"; smooth = yes; };  //sniper ring
	"telescope-sniper" = { model = "telescope-sniper.dat"; smooth = yes; //ring around visual target
		materials = { "telescope-ring.png" = { emission_color = darkGrayColor;};};};
	\n'''     

						
## class definitions ##########################################################


class MatchFailError( Exception ):			# for Plist decoder
	"""Exception raised for failed regex match."""

	def __init__( self, index, nextchar ):
		self.index = index
		self.nextchar = nextchar
	
class Entity:
	def __init__( self, name ):
		self.name = _unquote( name )        # its name, stripped of quotes (if any) from source; always quoted on output
		self.place = []                     # array of indices in source where entity definition starts
		self.origin = []                    # list of file source indices where it was found
		self.properties = {}                # dict of list(Property), mapping keys to list of value(s), eg. model: [] of Property
		self.lastplace = 0                  # index (relative to chosen .place) in output of end of entity definition
		self.comments = []                  # list of comments not associated w/ a Property
		self.output_oi = 0                  # index of origin file used to generate output
	def add_origin( self, file, place ):
		if file not in self.origin: 
			self.origin.append( file )
			self.place.append( 0 if place is None else int( place ) )
		return self.origin.index( file )
	def repl_origin( self, file, place ):   # Loading_data and it has source info, so overwrite COLLATE_FN, place
		self.origin[ 0 ] = file
		self.place[ 0 ] = place
		return 0
	def add_item( self, key, value ):
		if key in self.properties:
			self.properties[ key ].append( value )
		else:
			self.properties[ key ] = [ value ]
	def add_comment( self, comment, place, origID ):
		cmt = Comment( comment, place, self, origID )
		self.comments.append( cmt )
		
class Property:
	def __init__( self, key, place = 0, value = None, vplace = 0, origID = 0, inserted = False ):
		self.name = _unquote( key )         # its name, stripped of quotes, for comparison
		self.place = 0 if place is None \
					   else int( place )    # index in source where property name starts
		self.value = value                  # a Python object parsed from file sources
		self.vplace = 0 if vplace is None \
						else int( vplace )  # index in source where property definition starts
		self.plist = []                     # list of formatting strings representing its obj (may contain inline comments)
		self.length = 0                     # total length of items in plist
		self.lastplace = 0                  # index (relative to .place) in output of end of property definition
		self.origID = 0 if origID is None \
						else int( origID )  # index of origin file
		self.inserted = inserted            # flag for those generated using Keys_to_insert
		self.comments = []                  # list of comments associated w/ this Property
	def add_comment( self, comment, place ):
		cmt = Comment( comment, place, self, self.origID )
		self.comments.append( cmt )

class Comment:
	def __init__( self, comment, place = 0, assoc = None, origID = None ):
		self.text = comment                 # contents of the comment, incl'g comment char's
		self.place = 0 if place is None \
					   else int( place )    # index in source where it starts
		self.assoc = assoc                  # Entity or Property it's associated with
		self.lastplace = 0                  # index (relative to .place) in output of end of comment
		self.origID = 0 if origID is None \
						else int( origID )  # index of origin file

						
## errors & IO ################################################################


def _ent_load_warning( ent ):
	_log_error( '{} is corrupt, has duplicates entries for "{}"'.format( COLLATE_FILE, ent ) )

def _ent_file_msg( origin, ent, dups = None ):
	try:
		reg_ent = Registered_ents[ ent ]
		outI = reg_ent.output_oi
		if origin not in Files_logged: # only write it once
			Files_logged.append( origin )
			Logfile.write( '\nFile {}:\n'.format( SourceFileNames[ origin[ outI ] ] ) )
		files = len( origin )
		for index in range( files ):
			if index == outI: continue
			Logfile.write( '  - data also found in: {}\n'.format( SourceFileNames[ origin[ index ] ] ) )
	 
		def format_dups( count, duplist, string ):
			dup_names = []
			first = True
			for dup in duplist:
				if dup not in dup_names:
					dup_names.append( dup )
				else:
					continue
				if not first: 
					string += ', '
				if len( string ) - string.rfind( '\n' ) >= LOG_LINELEN:
					string += '\n    '
				first = False
				string += dup
			return string
		
		total = 0 if dups is None else len( dups )
		if total > 0:
			output = '  Warning!  {} contain{} {} with {}duplicate definition{} for:\n    '.format(
									'this file' if files == 2 else 'these files', 
									's' if files > 2 else '',
									'an entity' if total == 1 else 'entities',
									'a ' if files == 1 else '', 
									'' if files == 1 else 's' )
			dup_ents = list( dups.keys() )
			dup_ents.sort()
			output = format_dups( total, dup_ents, output )
			dup_keys = []
			for dup in dup_ents:
				prnames = dups[ dup ] # dups is a dict of ... ent: [(dup_key, orig_key)]
				for prop, origp in prnames:
					dup_keys.append( origp )
			length = len( dup_keys )
			dup_keys.sort()
			total += length
			output += '\n  key{} duplicated:\n    '.format( '' if length == 1 else 's' )
			output = format_dups( length, dup_keys, output )
			Logfile.write( output + '\n' )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_ent_file_msg,  dups: {}'.format( exc, dups ) )

def _ent_dup_error( dups ):
	try:
		for ent, dup_keys in dups.items():
			reg_ent = Registered_ents[ ent ]
			values = reg_ent.properties # dict of key, [value]
			curr_oi = reg_ent.output_oi
			dup_keys.sort()
			reported = dict()
			for prop, origp in dup_keys:
				curr = _str_minimize( values[ prop ][ curr_oi ].value, translate = False ); 
				if prop not in reported.keys():
					reported[ prop ] = []
				prop_dups = [ values[ prop ][ i ] for i in range( len( values[ prop ] ) ) if i != curr_oi ]
				for new in prop_dups:
					if new.value is None:  ## a stub placed in _select_origin
						continue
					dup = _str_minimize( new.value, translate = False );            
					if _equal_values( curr, dup ): # declutter the log; already noted under keys duplicated
						continue
					if dup in reported[ prop ]:
						continue
					else:
						reported[ prop ].append( dup )
					intro = '  {}[ {} ]: '.format( ent, origp )
					leni = len( intro );
					first = leni + len( curr )
					total = first + len( dup )
					spcr1 = '' if first < LOG_LINELEN else '\n        '
					spcr2 = '' if total < LOG_LINELEN else '\n    ' if first > LOG_LINELEN else '\n' + ' '*(leni - 4)
					Logfile.write( intro + '{}"{}" {} -> "{}"\n'.format( spcr1, dup, spcr2, curr ) )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_ent_dup_error,  dups: {}'.format(  exc,dups ) )
		
def _ent_logonly_warning( file, ent, prop ):
	_ent_file_msg( file, None, None )
	Logfile.write( '\n  **WARNING**  "{}" has a "log only" key "{}" -was ignored!\n\n'.format( ent, prop ) )

def _log_blankline():
	Logfile.write( '\n' )
	
def _log_message( msg ):
	if not LOG_MESSAGES: return
	_write_log( '', msg )

def _log_warning( msg ):
	if not LOG_WARNINGS: return
	_write_log( 'Warning:', msg, showfn = True )

def _log_error( msg ):
	if not LOG_ERRORS: return
	_write_log( 'Error!', msg, suffix = '\n', showfn = True )

Last_logged_fn = None    
def _write_log( type, msg, suffix = '', showfn = False ):
	global Last_logged_fn
	
	if type in ['Warning:', 'Error!',]:
		_log_blankline()
	if showfn and CurrentFile is not None:
		if CurrentFile != Last_logged_fn:
			Logfile.write( 'file: {}\n'.format( CurrentFile ) )
			Logfile.write( '      {}\n'.format( '=' * len( CurrentFile ) ) )
			Last_logged_fn = CurrentFile
	Logfile.write( '{}{}{} \n{}'.format( type, '' if type == '' else ' ', msg, suffix ) )


## tree walker ###############################################################

# def oxpDescendent( sub ):
	# parents = os.path.normpath( sub ).split( os.sep )
	# return any( par.lower().endswith( OXP_FOLDER_EXT ) for par in parents )

LowIncluded = []
LowExcluded = []
def includeExclude( sub ):
	if len( LowIncluded ) == 0 and len( Included_dirs ) > 0:
		LowIncluded.extend( incl.lower() for incl in Included_dirs )
	if len( LowExcluded ) == 0 and len( EXCLUDE_FOLDERS ) > 0:
		LowExcluded.extend( excl.lower() for excl in EXCLUDE_FOLDERS )
	check = sub.lower() + os.sep
	if len( Included_dirs ) != 0 and not any( (os.sep + incl + os.sep) in check for incl in LowIncluded ):
		return False
	if len( EXCLUDE_FOLDERS ) != 0 and any( (os.sep + excl + os.sep) in check for excl in LowExcluded ):
		return False
	return True
	
def _proc_dir( subs ):
	def rptFolder():
		if LogFoldersSearched and procFolder: # and \
				# ( not inOxpFolder or root.endswith( OXP_FOLDER_EXT )):
			if root not in reportedFolders:
				_log_message( '\nfolder {}'.format( root ) )
				reportedFolders.append( root )
				print( 'folder {}'.format( root ) )
	
	eSub = eRoot = eFile = None
	try:
		err = False
		if not isinstance( subs, list ):
			if isinstance( subs, str ):
				subs = [ subs ]
				# subs = list( subs )
			else:
				raise ValueError( 'proc_dir, invalid arg:', subs )
		reportedFolders = []
		folderTrimLen = len( OXP_FOLDER_EXT ) + len( os.sep )
		for sub in subs:
			eSub = sub
			for root, dirs, files in os.walk( sub ):
				eRoot = root
				if not includeExclude( root ): 
					continue
				lowRoot = root.lower()
# should all interaction w/ root be lower, ie. root = root.lower
				inOxpFolder = OXP_FOLDER_EXT in root
				if inOxpFolder:		# only go one folder deep inside oxp folders
					rest = root[ root.rfind( OXP_FOLDER_EXT ) : ]
					procFolder = rest == '' or rest.count( os.sep ) == 1
				else:
					inInclude = [ (incl, lowRoot.index( incl )) for incl in LowIncluded if incl in lowRoot ]
					if len( inInclude ):
						incl, index = max( inInclude, key=lambda x: x[0] )
						rest = root[ index+ len(incl) : ]
						procFolder = rest.count( os.sep ) == 1
# missing default value of procFolder for each iteration
				oxpFolder = root[ root.rfind( OXP_FOLDER_EXT ) + folderTrimLen : ] if OXP_FOLDER_EXT in root else ''
				print('  for {}\n\tprocFolder: {} as SearchOnlyOxpFolders is {} and inOxpFolder is {}, oxpFolder: "{}"'.format(
						root, procFolder, SearchOnlyOxpFolders, inOxpFolder, oxpFolder))
# SearchOnlyOxpFolders should continue if not inOxpFolder and we're not in a LowIncluded folder! 
				if os.sep in oxpFolder:
					continue
					
				rptFolder()
				if LogFoldersSearched and procFolder and oxpFolder:
					_log_message( '  scanning {}'.format( oxpFolder ) )
					reportedFolders.append( oxpFolder )
				for file in files:
					eFile = file
					_, ext = os.path.splitext( file )
					if procFolder and file.lower() == INPUT_FN: 
						if logFoldersProcessed and LogFoldersSearched:
							_log_message( '  -> loading: {}'.format( oxpFolder + os.sep + INPUT_FN ) )
						elif logFoldersProcessed:
							_log_message( '  -> loading: {}'.format( root + os.sep + INPUT_FN ) )
						path = os.path.join( root, file )
						with open( path ) as fp:
							err = _load_effects( fp, path ) or err
					elif ext in ZIPPEDFILES: 	
						err = _load_zipped_effects( root, file ) or err

	except IOError as msg:
		_log_warning( '_proc_dir, subs = "{}", sub = "{}"'.format( subs, eSub ) )
		_log_warning( '_proc_dir, eRoot = "{}", eFile = "{}"'.format( eRoot, eFile ) )
		_log_error( '	{}\n'.format( msg ) )
		err = True
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_proc_dir, sub = "{}"'.format( exc, eSub ) )
			print( '	eRoot = "{}", eFile = "{}"'.format( eRoot, eFile ) )
		err = True
	return err
	
def _load_zipped_effects( root, file ):
	try:
		err = False
		path = os.path.join( root, file )
		if zipfile.is_zipfile( path ):
			_, oxzName = os.path.split( path )
			if LogOxzSearched:
				_log_message( '  checking zip {}'.format( oxzName ) )
			with zipfile.ZipFile( path ) as zipf:
				zips = zipf.namelist()
				ziplist = []
				for zip in zips:
					zpath, zfn = os.path.split( zip )
					if zfn.lower() == INPUT_FN:
						ziplist.append( (zpath, zip) )
				for zpath, zip in ziplist:
					with zipf.open( zip, mode = 'r' ) as fp:
						if logOxzProcessed and LogOxzSearched:
							_log_message( '  -> loading: {}'.format( zpath + os.sep + INPUT_FN ) )
						elif logOxzProcessed:
							_log_message( '  -> {}: loading: {}'.format( oxzName, zpath + os.sep + INPUT_FN ) )
						err = _load_effects( fp, path ) or err
		else:
			raise ValueError( '_load_zipped_effects, not a zipfile', path )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_proc_dir, root = "{}", file = "{}"'.format( exc, root, file ) )
	return err
	
	
## proc interface #############################################################

	
def _load_effects( fp, file ):
	global CurrentFile, Existing_size, Input_size, Input_file_count
	
	err = False
	if LogDupsWithCollation:
		LogOnlyDifferentDups = True
	try:
		CurrentFile = file
		plist = fp.read()
		length = len( plist )
		if length == 0: 
			_log_error( 'Failed to read file; length of 0' )
			return True
		inside_oxz = True if isinstance( plist, bytes ) else False
		xml_test = b'<?xml' if inside_oxz else '<?xml'
		if plist.startswith( xml_test ):
			Input_size += length
			if inside_oxz: # zipfiles return bytes, not str
				parsed = readPlistStream( plist )
			else:
				# fp.seek( 0 )
				# parsed = plistlib.load( fp, fmt = plistlib.FMT_XML  )
				fp.close()
				fp = open( file, 'rb' )
				parsed = readPlistFile( fp )
		else:
			if Loading_data:
				Existing_size += length + plist.count( '\n' )
			else:
				Input_size += length
			if inside_oxz: # zipfiles return bytes, not str
				plist = plist.decode( encoding = "utf-8", errors = "strict" )
			parsed, _ = PListDecode( plist ) # returns tuple (obj,index of next char, ie. eof)
		if parsed is not None:
			if not inside_oxz:
				_log_message( '-> loading file {}'.format( file ) )
			Input_file_count += 1
			if isinstance( parsed, dict ):
				_proc_entities( file, parsed )
			#else: # plist files which are not dicts are not yet supported
			# eg. equipment.plist (list of lists)
		else:
			err = True;
			_log_error( 'file failed to parse!' )
	except xml.parsers.expat.ExpatError as xerr:
		err = True;
		if inside_oxz:
			plist = plist.decode( encoding = "utf-8", errors = "strict" )
		lines = plist.splitlines()
		context = errcontext( lines[ xerr.lineno - 1 ], xerr.offset )
		_log_error( "line {}, column {}: {}{}".format( 
				xerr.lineno, xerr.offset, xml.parsers.expat.errors.messages[ xerr.code ], context ) )
	except ValueError as verr:
		err = True;
		_log_error( verr )
	except Exception as exc:
		err = True;
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_load_effects, file = "{}"'.format( exc, file ))
	finally:
		CurrentFile = None
	return err
 
# '#' + str( index ) + '#' + key + '##'     for dict keys, list values & actual comments
# '#' + str( index ) + '#' + COMMENT_MARKER + str( count ) + '##'    for comment keys
PLACEMENT_RE = re.compile( r'''
			\# (\d+) \# (                           # placement number
			   ( .*? )
			) \#\#
			''', re.VERBOSE | re.DOTALL | re.MULTILINE )

def _encode_placement( info, place, comment = False ): # encode 'info' with 'place' (and code for comments)
	# placement is needed at all levels for sorting
	# this makes Registered_ents objects have a mix of encoded and decoded keys (but consistent on each level)
	# - remove placement to find dups of entity keys, but not sub-keys
	if comment:
		return '#' + str( place ) + '#' + COMMENT_MARKER + str( info ) + '##'
	else:
		return '#' + str( place ) + '#' + str( info ) + '##' 

def _decode_placement( string ): # break string into data and placement index, del any \r
	try:
		info = string
		place = None
		if isinstance( string, str ) and string.startswith( '#' ) and string.endswith( '##' ):
			match = PLACEMENT_RE.match( string )
			if match is not None: 
				place = match.group( 1 )
				info = match.group( 2 )
		if isinstance( string, str ):
			info = info.replace( '\r', '' )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_decode_placement, string is a{}\n{}'.format( exc, type( string ), string ))
	return info, place 

def _unquote( string ):
	if string[ 0 ] in QUOTES and string[ -1 ] == string[ 0 ]:
		string = string[ 1:-1 ]
	return string

CurrentEnt = None
TopLevelComments = []
def _proc_entities( file, pl ):
	global CurrentEnt
	
	try:
		order = []
		for cdent in pl.keys():
			info, place = _decode_placement( pl[ cdent ] if COMMENT_MARKER in cdent else cdent )
			order.append( [ 0 if place is None else int( place ), cdent ] )
		order.sort( key = itemgetter( 0 ) )  # restrict sort to placement only, keys in original order 
		ordered = list( item[ 1 ] for item in order )
		for cdent in ordered:
			ent, place = _decode_placement( cdent )
			if ent in Entities_to_ignore: continue
			if COMMENT_MARKER in cdent: # an unassociated comment? save and attach to 1st ent
				TopLevelComments.append( pl[ cdent ] )
				continue # ent is of no further use (placement encoded in comment)
			CurrentEnt = ent
			if ent in Registered_ents.keys(): # duplicate definition
				if Loading_data:
					_ent_load_warning( ent )
					return
			else:
				Registered_ents[ ent ] = Entity( ent )
			entity = Registered_ents[ ent ]
			if file not in SourceFileNames:
				SourceFileNames.append( file )
			origID = entity.add_origin( SourceFileNames.index( file ), place )
			if len( TopLevelComments ) > 0:
				for comment in TopLevelComments:
					_add_comment( comment, origID )
				del TopLevelComments[:]
			if isinstance( pl[ cdent ], dict ): # eg. shipdata.plist
			# also trapped in _load_effects
				for cdprop in _sort_dict_keys( pl[ cdent ] ):
					prop, pplace = _decode_placement( cdprop )
					if Loading_data and prop == 'origin':   # collated data has sources, repl origin & place
						origin = pl[ cdent ][ cdprop ]      # - pplace is None as collated src file comments not encoded
						for srcfn in origin:
							# if srcfn != COLLATE_FN or LogDupsWithCollation:
							if srcfn not in SourceFileNames:
								SourceFileNames.append( srcfn )
						origID = entity.repl_origin( SourceFileNames.index( origin[ -1 ] ), len( origin ) )
					if prop in Keys_to_log_only:
						_ent_logonly_warning( file, ent, prop )
					elif COMMENT_MARKER in cdprop: # just pass through, no formatting here
						_add_comment( pl[ cdent ][ cdprop ], origID )
					elif len( Keys_to_output ) == 0 or prop in Keys_to_output: # len == 0 => proc all attrs
						_proc_entity_key( pl, cdent, cdprop, ent, origID )
					else:
						# _log_error( 'found attribute ({}) with no directive'.format( prop ) )
						pass
			elif isinstance( pl[ cdent ], str ): # eg. missiontext (dict of str)
				prop, pplace, cdvalue, value, property = _add_entity_key( pl, cdent, None, origID )
				vlist = []
				write_str( value, '{}{}{};', vlist ) 
				property.plist.extend( vlist )
				property.length = sum( len( str( pl ) ) for pl in vlist )
			#else: # plist files which are just strings are not yet supported, eg. manifest, missiontext
		if len( TopLevelComments ) > 0: # comments at end of file
			for comment in TopLevelComments:
				_add_comment( comment, origID )
			del TopLevelComments[:]
		CurrentEnt = None
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_proc_entities, file is {}'.format( exc, file ))
  
def _add_comment( cdvalue, origID ):
	value, vplace = _decode_placement( cdvalue )
	Registered_ents[ CurrentEnt ].add_comment( value, vplace, origID )
  
def _add_entity_key( pl, cdent, cdprop, origID ):
	try:
		ent, place = _decode_placement( cdent )
		prop, pplace = _decode_placement( cdprop )
		cdvalue = pl[ cdent ] if cdprop is None else pl[ cdent ][ cdprop ]
		value, vplace = _decode_placement( cdvalue )
		if prop in Keys_to_rename: 
			prop = Keys_to_rename[ prop ]
			key = _encode_placement( prop, pplace )
		else:
			key = cdprop
		if cdprop is None:
			property = Property( ent, place, value, vplace, origID )
		else:
			property = Property( prop, pplace, value, vplace, origID )
		reg_ent = Registered_ents[ ent ]
		reg_ent.add_item( prop, property )
		if key is not None and prop in Keys_to_insert.keys():
			iplace = 0 if pplace is None else int( pplace )
			for ikey, ivalue in Keys_to_insert[ prop ].items():
				# must ensure a value is inserted for each origID, else lists won't align on output
				if all( ikey not in key for key in pl[ cdent ].keys() ): # is present in cdent
					iproperty = Property( ikey, iplace - 2, ivalue, iplace - 1, origID, True )
					iproperty.plist.append( str( ivalue ) + ';' )
					reg_ent.add_item( ikey, iproperty )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_add_entity_key, ent is {}, cdprop is {}'.format( exc, ent, cdprop ))
	return prop, pplace, cdvalue, value, property

def _is_float( str ):
	try:
		float( str )
	except ValueError:
		return False
	else:
		return True
		
def _proc_entity_key( pl, cdent, cdprop, ent, origID ):
	try:
		prop, pplace, cdvalue, value, property = _add_entity_key( pl, cdent, cdprop, origID )
		vlist = [] # list of tokens for value's output
		compact = 0 # default is now, N > 0 delay for N levels
		if prop in Keys_to_compact:
			compact = 1 # new style definition require special formatting (less whitespace)
			if prop == 'subentities': # old vs new style: list of str vs list of dict
				if len( cdvalue ) > 0:
					compact = 1 if isinstance( cdvalue[0], str ) else 2
		if isinstance( cdvalue, list ):
			idx_to_del = []
			for i in range( len( cdvalue ) ): # check for comments, as parser may place them inside
				dct = cdvalue[ i ]
				if RemoveFlasherSubEnts and prop == 'subentities':
					if isinstance( dct, str ):
						flasher, _ = _decode_placement( dct )
						if flasher.startswith( '*FLASHER*' ): # armoury_fieldMine
							idx_to_del.append( i )
					elif isinstance( dct, dict ):
						for encKey, encVal in dct.items():
							dk, _ = _decode_placement( encKey )
							dv, _ = _decode_placement( encVal )
							if dk == 'type' and dv == 'flasher':
								idx_to_del.append( i )
				if not isinstance( dct, dict ): continue
				for cmtkey, cmtvalue in dct.items():
					if COMMENT_MARKER not in cmtkey: continue
					cmttext, cmtplace = _decode_placement( cmtvalue )
					if cmtplace >= pplace: # comment belongs inside
						continue
					_add_comment( cmtvalue, origID )
					idx_to_del.append( i )
			idx_to_del.reverse()
			for i in idx_to_del:
				cdvalue.pop( i )
			if len( cdvalue ) > 0:
				write_list( vlist, cdvalue, 2, compact )
			elif not property.inserted and len( property.comments ) == 0:
				del Registered_ents[ ent ].properties[ prop ]
		elif isinstance( cdvalue, dict ):
			key_to_del = []
			for cmtkey, cmtvalue in cdvalue.items():
				if COMMENT_MARKER not in cmtkey: continue
				cmttext, cmtplace = _decode_placement( cmtvalue )
				if cmtplace >= pplace: # comment belongs inside
					continue
				_add_comment( cmtvalue, origID )
				key_to_del.append( cmtkey )
			for cmtkey in key_to_del:
				del cdvalue[ cmtkey ]
			if prop in Subkeys_to_insert_if_empty.keys():
				subs_to_insert = Subkeys_to_insert_if_empty[ prop ]
				for encValKey, encValValue in value.items(): # decode subkeys so can test if empty
					if not isinstance( encValValue, dict ): continue
					valKey, _ = _decode_placement( encValKey )
					subkeys = {}
					for encVk, encVv in encValValue.items():
						vk, _ = _decode_placement( encVk )
						vv, _ = _decode_placement( encVv )
						subkeys[ vk ] = vv
					existingKeys = subkeys.keys()
					if any( k in existingKeys for k in subs_to_insert.keys() ): # see if in use
						continue # not empty
					for keyToAdd, valueToAdd in subs_to_insert.items():
						value[ encValKey ][ keyToAdd ] = valueToAdd
			write_dict( vlist, cdvalue, 2, compact )
		elif isinstance( cdvalue, bool ):
			vlist.extend( [ 'yes' if value else 'no', ';' ] )
		elif isinstance( value, float ) or isinstance( value, int ):
			vlist.extend( [ value, ';' ] )
		elif value.isdigit():
		# elif value.isdecimal(): # Python3 only (there are 4 other instances)
			vlist.extend( [ int( value ), ';' ] )
		elif _is_float( value ):
			vlist.extend( [ float( value ), ';' ] )
		else:
			if len( value ) == 0: qt = '"' # allow for empty strings
			else:
				qt = '"'  if NONWORD.search( value ) else ''
			vlist.append( '{}{}{};'.format( qt, value, qt ) )
		property.plist.extend( vlist )
		property.length = sum( len( str( pl ) ) for pl in vlist )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_proc_entity_key, ent is {}, cdprop is {}'.format( exc, ent, cdprop ))
		
		
## NextStep format ############################################################


# write_dict() & write_list() adapted from work by Cdr. Jettison
# http://aegidian.org/bb/viewtopic.php?f=2&t=10039&start=39

NONWORD = re.compile(r'\W') # if keys contain this pattern, they'll be
							# put in quotes (the keys on the outmost
							# level are always quoted)
QUOTEDNUMBER = re.compile( r'''
				^(?P<qt>[''' + QUOTES + r''']?)         # opening quote (maybe)
				(
						[-+]?                           # sign (maybe)
					(\d+ (?!/)                          # number (with no slash)
						(\.\d*)?)                       # a decimal part (maybe)
						( [eE] [-+]? \d+ )?             # exponent (maybe)
				  | ( (\d+)\s*/\s*(\d+) )               # or fraction
				)
				(?(qt) (?P=qt) | $ )                    # matching quote (if present)
				''', re.VERBOSE ) # strict pattern as used to omit quotes in output

def write_str( value, fmt, plist ):
	if len( value ) == 0 or any( c in value for c in WHITESPACE_CHAR ):
		qt = '"'
	else:
		qtnum = QUOTEDNUMBER.match( value )
		if qtnum:
			qt = ''
			value = qtnum.group( 2 ) # group 1 is the quote
		else:
			qt = '"' if NONWORD.search( value ) else ''
	plist.append( fmt.format( qt, value, qt ) )
			   
def _sort_dict_keys( dict ):
	keys = dict.keys()
	try:
		order = []
		for key in keys:
			info, place = _decode_placement( dict[ key ] if COMMENT_MARKER in key else key )
			order.append( [ 0 if place is None else int( place ), key ] )
		order.sort( key = itemgetter( 0 ) )  # restrict sort to placement only
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_sort_dict_keys, keys is {}'.format( exc, keys ))
	return list( item[ 1 ] for item in order ) # ordered list of keys

def _sort_list_items( array ):
	def get_list_placement( x ):
		_, pl = _decode_placement( x )
		return pl
	def get_dict_placement( x ):
		k, v = x
		_, pl = _decode_placement( v if COMMENT_MARKER in k else k )
		return pl
	sort_by_index = True
	order = []
	for index in range( len( array ) ):
		item = array[ index ]
		if isinstance( item, dict ):
			places = list( map( get_dict_placement, item.items() ) )
			place = min( 10e10 if place is None else place for place in places )
		elif isinstance( item, list ):
			places = list( map( get_list_placement, item ) )
			place = min( 10e10 if place is None else place for place in places )
		else:
			_, place = _decode_placement( item )
		if place is None: # no placement (XML source), fit into order
			placement = 0 if len( order ) == 0 else order[ -1 ][ 0 ] + 1 # incr placement of last entry
		else:
			placement = int( place )
		order.append( [ placement, index ] )
	order.sort( key = itemgetter( 0 ) )  # restrict sort to placement only         
	return list( item[ 1 ] for item in order )  
							
def line_empty( lst, endings = '' ): # test line (str or list of str) is blank or ends in member(s) of 'endings'
	try:
		start = _find_line_start( lst, len( lst ) )
		if start is None: start = 0 # no NL char
		trim = len( endings ) == 0
		i = len( lst )
		while i > start:
			i -= 1
			word = lst[ i ]
			strpped = word.strip() if trim else word.rstrip()
			if '\n' in word and strpped == '': return True
			if strpped == '': continue
			if trim: return False
			if any( strpped.endswith( c ) for c in endings ):
				return True
			return False
		return True
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\nline_empty, item, type {}, is "{}"'.format( exc, type( item ), lst[ index ] ))
	
def write_dict( plist, dct, lvl, compact = 0, inlist = False ):
	'''Writes dictionary into object plist. Recursion as needed'''

	value = None # init for exception print()
	try:
		same_line = compact == 0 and lvl > 3
		plstart = len( plist )
		if not same_line and (len( plist ) == 0 or not line_empty( plist, '({,' )):
			plist.extend( [ '\n', '\t' * lvl ] )
		plist.append( '{' )
		order = _sort_dict_keys( dct )
		for cdkey in order:
			key, kplace = _decode_placement( cdkey )
			cdvalue = dct[ cdkey ]
			value, vplace = _decode_placement( cdvalue )
			if COMMENT_MARKER in key:
				if inlist:
					if len( order ) == 1: # in simple lists, comment is a 1 key dict 
						del plist[ plstart: ]
					else:
						liststart = _find_open_list( plist )
						if liststart is not None:
							del plist[ liststart + 1: ]
				# else: # comments in dict treated as keys, so trim any NL char
					# ending = _endswith_NL( value )
					# if ending is not None:
						# value = value[ :ending ]
				ending = _endswith_NL( value ) # trim any NL char
				if ending is not None:
					value = value[ :ending ]
				plist.append( value )
				if inlist and len( order ) == 1:
					return True # to suppress commas if called from write_list
				continue
			if not same_line and not line_empty( plist ):
				plist.extend( [ '\n', '\t' * (lvl + 1) ] )
			qt = '"' if NONWORD.search( key ) else ''
			plist.extend( [ '{}{}{}'.format( qt, key, qt ), '=' ] )
			if isinstance( cdvalue, list ):
				if lvl == 3 and key in Subkeys_to_compact:
					nextcompact = 1
				else:
					nextcompact = 0 if compact <= 1 else compact - 1
				write_list( plist, value, lvl + 1, nextcompact, False ) # )
			elif isinstance( cdvalue, dict ):
				if lvl == 3 and key in Subkeys_to_compact: 
					nextcompact = 1
				else:
					nextcompact = 0 if compact <= 1 else compact - 1
				write_dict( plist, value, lvl + 1, nextcompact, False ) # )
			elif isinstance( cdvalue, bool ): ## ?should we try to convert OpenStep booleans
				plist.extend( [ 'yes' if value else 'no', ';' ] )
			elif isinstance( value, float ) or isinstance( value, int ):
				plist.extend( [ value, ';' ] )
			elif value.isdigit():
				plist.extend( [ int( value ), ';' ] )
			elif _is_float( value ):
				plist.extend( [ float( value ), ';' ] )
			else: # isinstance( value, str )
				write_str( value, '{}{}{};', plist )
		if not same_line:
			plist.extend( [ '\n', '\t' * lvl ] )
		plist.append( '}' )
		if not inlist: plist.append( ';' )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\nwrite_dict, value, type {}, is "{}"'.format( exc, type( value ), value ))
	return False

def write_list( plist, lst, lvl, compact = 0, inlist = False ):
	'''Writes list as array into object plist. Recursion as needed'''

	value = None
	try:
		same_line = compact == 0 and lvl > 2
		if not same_line and (len( plist ) == 0 or not line_empty( plist, '({,' )):
			plist.extend( [ '\n', '\t' * lvl ] )
		plist.append( '(' )
		first = True
		order = _sort_list_items( lst )
		for index in order:
			cdvalue = lst[ index ]
			value, _ = _decode_placement( cdvalue )
			if not first: plist.append( ',' )
			first = False
			if not same_line and not line_empty( plist ):
				plist.extend( [ '\n', '\t' * (lvl + 1) ] )
			if isinstance( cdvalue, list ):
				write_list( plist, cdvalue, lvl + 1, 0 if compact <= 1 else compact - 1, True )
			elif isinstance( cdvalue, dict ):
				# write_dict returns True for comments to suppress commas
				first = write_dict( plist, cdvalue, lvl + 1, 0 if compact <= 1 else compact - 1, True )
			elif isinstance( cdvalue, bool ): ## ?should we try to convert OpenStep booleans
				plist.append( 'yes' if value else 'no' )
			elif isinstance( value, float ) or isinstance( value, int ):
				plist.append( value )
			elif value.isdigit():
				plist.append( int( value ) )
			elif _is_float( value ):
				plist.append( float( value ) )
			else:
				write_str( value, '{}{}{}', plist )
		if not same_line:
			plist.extend( [ '\n', '\t' * lvl ] )
		plist.append( ')' )
		if not inlist: plist.append( ';' )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\nwrite_list, value, type {}, is "{}"'.format( exc, type( value ), value ))

	
## OpenStep parser ############################################################

'''
MIT License
===========

Copyright (c) 2017, Samuel Bishop
Copyright (c) 2014, Fireteam Ltd.
See AUTHORS for more details.

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

- 'decoder.py' & 'scanner.py' included and (heavily) modified for oolite
'''
STRIP_PLACE_RE = re.compile( r'''
			\# \d+ \#                            # placement number
			   ( .*? )
			\#\#
			''', re.VERBOSE | re.DOTALL | re.MULTILINE )
   
def linecol( doc, pos ):
	lineno = doc.count( '\n', 0, pos ) + 1
	if lineno == 1:
		colno = pos
	else:
		colno = pos - doc.rindex( '\n', 0, pos )
	return lineno, colno

def errmsg( msg, doc, pos, index = None ):
	decmsg = STRIP_PLACE_RE.sub( r'\1', msg )
	lineno, colno = linecol( doc, pos )
	if index is None:
		fmt = 'line {0}, column {1} (char {2}): {3}'
		error = fmt.format( lineno, colno, pos, decmsg )
	else:
		endlineno, endcolno = linecol( doc, index )
		fmt = 'line {0}, column {1} - line {2}, column {3} (char {4} - {5}); {6}'
		error = fmt.format( lineno, colno, endlineno, endcolno, pos, index, decmsg )
	error += errcontext( doc, pos )
	return error
	
def errcontext( doc, pos ):
	start = 0 if pos < 40 else pos - 40
	errnl = '\n    ... '
	errpref = doc[ start:pos ].replace( '\n', '').replace( '\t', '  ' ).replace( '\r', '' )
	pointer = '\n' + ' ' * (len( errnl ) + len( errpref ) - 1) + '^'
	errsuff = doc[ pos:pos + 40 ].replace( '\n', '').replace( '\t', '  ' ).replace( '\r', '' )
	return errnl + errpref + errsuff + ' ...' + pointer

#STRINGCHUNK = re.compile(r'''(.*?)(["'\\\x00-\x1f])''', re.VERBOSE | re.DOTALL )
QUOTES_SUPPORTED = [] 
# make regex for each quote char to ensure starting matches ending and others allowed in string
#   "(?:\\.|[^"\\])*"   from StackOverflow
	
for qt in QUOTES:
	# QUOTES_SUPPORTED.append( [ qt, re.compile( r'(.*?)([' + qt + '\\\x00-\x1f])' ) ] )
	QUOTES_SUPPORTED.append( [ qt, re.compile( r'((?:\\.|[^' + qt + r'\\])*)([' + qt + r'\x00-\x1f\x7f])' ) ] )

def PListString( string, index, encoding = "utf-8" ):
	"""Scan 'string' for a plist quoted string. 'index' is of the
	character in 'string' after the quote that started the plist string.
	Unescapes all valid plist string escape sequences and raises ValueError
	on attempt to decode an invalid string.

	Returns a tuple of the decoded string and the index of the character in string
	after the end quote."""
	
	initiator = string[ index - 1 ] # quote char that starts a quoted string
	_match = None
	for qt, regex in QUOTES_SUPPORTED:
		if initiator == qt:
			_match = regex.match
			break
	if _match is None:
		raise ValueError( errmsg( "Unsupported quote char for string starting at", string, begin ) )       
	chunks = []
	begin = index - 1
	while True:
		chunk = _match( string, index )
		if chunk is None:
			raise ValueError( errmsg( "Unterminated string starting at", string, begin ) )
		index = chunk.end()
		content, terminator = chunk.groups() # each QUOTES_SUPPORTED has only 2 groups
		# Content is contains zero or more unescaped string characters
		if content:
			if not isinstance( content, str ):
				content = content.encode( encoding )
				# content = str( content, encoding )	# works in Python3
			chunks.append( content )
		# Terminator is the end of string, a literal control character,
		# or a backslash denoting that an escape sequence follows
		if terminator in QUOTES:
			break
		elif terminator != '\\':
			if string[ index - 1 ] == '\t': # oolite tolerates tabs in strings
				chunks.append( '\t' )
				continue
			else:
				msg = "Invalid control character {0!r} at".format( terminator )
				raise ValueError( errmsg( msg, string, index ) )
		try:
			esc = string[ index ]
		except IndexError:
			raise ValueError( 
				errmsg( "Unterminated string starting at", string, begin ) )
		# If not a unicode escape sequence, must be in the lookup table
		if esc != 'U':
			msg = "Invalid \\escape: " + repr( esc )
			raise ValueError( errmsg( msg, string, index ) )
		else:
			# Unicode escape sequence
			esc = string[ index + 1:index + 5 ]
			next_end = index + 5
			if len( esc) != 4:
				msg = "Invalid \\UXXXX escape"
				raise ValueError( errmsg( msg, string, index ) )
			uni = int( esc, 16 )
			# Check for surrogate pair on UCS-4 systems
			if 0xd800 <= uni <= 0xdbff and sys.maxunicode > 65535:
				msg = "Invalid \\UXXXX\\UXXXX surrogate pair"
				if not string[ index + 5:index + 7 ] == '\\u':
					raise ValueError( errmsg( msg, string, index ) )
				esc2 = string[ index + 7:index + 11 ]
				if len( esc2) != 4:
					raise ValueError( errmsg( msg, string, index ) )
				uni2 = int( esc2, 16 )
				uni = 0x10000 + ( ( (uni - 0xd800) << 10 ) | (uni2 - 0xdc00) )
				next_end += 6
			char = chr( uni )
			index = next_end
		# Append the unescaped character
		chunks.append( char )
	
	return ''.join( chunks ), index

WHITESPACE_RE = re.compile( r'[ \t\n\r]*', re.VERBOSE | re.MULTILINE | re.DOTALL )
WHITESPACE_CHAR = ' \t\n\r'

def _skip_WS( string, index, _WSmatch = WHITESPACE_RE.match, _WSstr = WHITESPACE_CHAR ):
	started = index # save index before skip for correct error msgs
	nextchar = ''
	try:
		nextchar = string[ index ]
		if nextchar in _WSstr:
			index = _WSmatch( string, index ).end()
			nextchar = string[ index ]
		if nextchar == '/':
			return PListComment( string, index + 1 )
	except IndexError:
		pass # found none
	return nextchar, index, started

CLOSECOMMENT = re.compile( r'.*?(\*/)', re.VERBOSE | re.MULTILINE | re.DOTALL )
MATCH2EOL = r'(.*?\n)'
EOLCOMMENT = re.compile( '(' + ORIGIN_MARKER + ')?' + MATCH2EOL, re.VERBOSE )

PendingComments = []    # store comments until safe to insert into plist object
CommentKey = None       # dict key or list in which the comment appears; used to construct key 
CommentCount = 0        # append # to key so they're unique

def PListComment( string, index ):
	""" comments can appear anywhere, so this gets called often,
		every time we 'scan' or skip whitespace
	"""
	global Data_origin

	nextchar = string[ index ]
	eol_style = nextchar == '/'
	find_close = nextchar == '*'
	cmt_start = index - 1
	try: # must gobble up ALL consecutive comments, even a mixture (but not nested!)
		if eol_style: # need to inspect ea for ORIGIN_MARKER
			match = EOLCOMMENT.match( string, index + 1 )
			if match is not None: 
				index = match.end() # points at eol
				nextchar = string[ index ]
				if match.lastindex == 2 and match.group( 1 ) == ORIGIN_MARKER:
					# we're Loading_data and found src file comment
					origin = match.group( 2 ).strip()
					if LogDupsWithCollation or origin != COLLATE_FN:
						if Data_origin is None:
							Data_origin = [ origin ] 
						elif origin not in Data_origin:
							Data_origin.append( origin )
			else:
				raise ValueError( errmsg( "Invalid comment - no eol??", string, index ) ) 
		elif find_close:
			match = CLOSECOMMENT.match( string, index + 1 )
			if match is not None: 
				index = match.end()
				nextchar = string[ index ]
			else:
				raise ValueError( errmsg( "Invalid comment - no closing */", string, index ) )
		if (Loading_data and RetainDBComments) or (not Loading_data and RetainSourceComments):
			prefix = _find_cmt_prefix( string, cmt_start )
			if prefix is None: prefix = cmt_start
			suffix = _find_cmt_suffix( string, index, eol_style ) # points at eol
			if suffix is None: suffix = index
			comment = _encode_placement( string[ prefix:suffix ], prefix )
			PendingComments.append( [ CommentKey, comment, prefix ] )
	except IndexError:
		raise StopIteration
	return _skip_WS( string, index )

def _insert_comments( index, inDict = False ): # almost identical code for storing comments that appear in lists or dictionaries
	global CommentCount
	
	comments = []
	while len( PendingComments ) > 0:
		key, comment, place = PendingComments.pop()
		if key is None: key = '--root--'
		marker = _encode_placement( key + '!' + str( CommentCount ), place, comment = True )
		if( inDict ):   # PListDictionary builds a list of tuples that's converted to a dict on exit
			comments.append( (marker, comment) )
		else:           # PListArray builds its list on the fly
			comments.append( dict( { marker: comment } ) )
		CommentCount += 1
	return comments
	
DictLevel = 0
def PListDictionary( string, index ):
	global Data_origin, DictLevel, CommentKey

	nextchar, index, _ = _skip_WS( string, index )
	pairs = _insert_comments( index, inDict = True )
	# Trivial empty object
	if nextchar == '}':
		return pairs, index + 1
	DictLevel += 1
	origin_set = False
	while True:
		key_start = index
		try: # fetching the key
			key, index = PL_scan_name( string, index )
		except StopIteration:
			raise ValueError( errmsg( "Expecting property name", string, index ) )
		CommentKey = key
		pairs.extend( _insert_comments( index, inDict = True ) )

		if LogUnquotedDash and '-' in key and string[ key_start ] not in QUOTES:
			key = '"' + key + '"'
			_log_error( errmsg( "(non-fatal) Unquoted ship key {} containing a '-'".format( key ), string, index ) ) 
		ekey = _encode_placement( key, index ) 
		
		nextchar, index, started = _skip_WS( string, index )
		if nextchar != '=':
			raise ValueError( errmsg( "Expecting = delimiter", string, started ) )
		index += 1 # step past '='
		pairs.extend( _insert_comments( index, inDict = True ) )

		nextchar, index, started = _skip_WS( string, index )
		try: # fetching the key's value
			value, index = PL_scan_once( string, index )
		except StopIteration:
			delim = -1
			if index < len( string ): # re failed, assume "" (oxp is verified, right?)
				semic = string.find( ';', index )
				comma = string.find( ',', index )
				if semic != -1 and semic < comma: delim = semic
				elif comma != -1 and comma < semic: delim = comma
			if delim != -1:
				_log_error( errmsg( '(non-fatal) Found no value for {}, using ""'.format( key ), string, started ) )
				value = '""'
				index = delim
			else:
				raise ValueError( errmsg( "Expecting dictionary", string, index ) )
		evalue = value       
		if type( value ) not in [ dict, list ]: # encode for proper placement
			evalue = _encode_placement( value, index )
		pairs.append( (ekey, evalue) )
		pairs.extend( _insert_comments( index, inDict = True ) )
		
		if DictLevel == 2 and Loading_data and not origin_set and Data_origin is not None:
			pairs.append( ('origin', Data_origin ) ) # save source of ship data definition
			Data_origin = None
			origin_set = True

		nextchar, index, started = _skip_WS( string, index )
		if nextchar == ';' or \
			( nextchar == ',' and type( value ) in [ 'list', 'dict' ] ):
			index += 1# step past semi-colon/comma
		elif nextchar in ')}': # missing final semi-colon (oolite tolerates)
			if LogMissingSemiColon: # will be added on output
				errval = '{}'.format( value );
				if len( errval ) > 50:
					errval = errval[ -50: ]
				_log_error( errmsg( '(non-fatal) missing ";"', string, started ) )
		else:
			raise ValueError( errmsg( "Expecting ; or , delimiter", string, index - 1 ) )

		nextchar, index, _ = _skip_WS( string, index )
		if nextchar == '}':
			index += 1 # step past closing brace
			break
		pairs.extend( _insert_comments( index, inDict = True ) )

	CommentKey = None
	pairs.extend( _insert_comments( index, inDict = True ) )
	pairs = dict( pairs )
	DictLevel -= 1
	return pairs, index

def PListArray( string, index ):
	nextchar, index, _ = _skip_WS( string, index )
	values = _insert_comments( index )
	# Look-ahead for trivial empty array
	if nextchar == ')':
		return values, index + 1
	while True:
		try: # fetching an array item
			value, index = PL_scan_once( string, index )
		except StopIteration:
			raise ValueError( errmsg( "Expecting object", string, index ) )
		
		if type( value ) not in [ dict, list ]: # encode for proper placement
			value = _encode_placement( value, index )
		values.append( value )
		values.extend( _insert_comments( index ) )
		
		nextchar, index, _ = _skip_WS( string, index )
		if nextchar == ')':
			index += 1 # step past closing parenthesis
			break
		elif nextchar != ',':
			raise ValueError( errmsg( "Expecting , delimiter", string, index ))
		index += 1# step past comma

		nextchar, index, _ = _skip_WS( string, index )
		if nextchar == ')': # trailing commas are allowed
			index += 1 # step past closing parenthesis
			break

	values.extend( _insert_comments( index ) )
	return values, index

def PListDecode( string, index = 0 ):
	"""Decode a plist document from ``string`` (a ``str`` or ``unicode``
	beginning with a plist document) and return a 2-tuple of the Python
	representation and the index in ``string`` where the document ended.

	This can be used to decode a plist document from a string that may
	have extraneous data at the end.
	"""
	global CommentKey

	CommentKey = None # reset for each new file so root comments get keyyed correctly
	try:
		_, index, _ = _skip_WS( string, index )
		obj, index = PL_scan_once( string, index )
	except MatchFailError as err:
		_log_error( errmsg( 'PListDecode, No plist object could be decoded (MatchFailError at "{}").'.format( err.nextchar ), string, err.index ) )
		return None, 0
	except StopIteration:
		_log_error( errmsg( 'PListDecode, No plist object could be decoded (StopIteration).', string, index ) )
		return None, 0
	except ValueError as err: # catch-all for parse errors
		_log_error( err )
		return None, 0
	return obj, index

# ALPHANUMERIC = r'''
				# ( [a-zA-Z0-9\-\._]+ )           # identifier, filename, even with dashes
				# | (   [-+]?                     # or number     # sign (maybe)
					# (\d+ (?!/)                                  # number (with no slash)
						# (\.\d*)? | \.\d+)                       # maybe a decimal part
					# ( [eE] [-+]? \d+ )?                         # exponent (maybe)
					# | ( (\d+)\s*/\s*(\d+)) )                    # or fraction
				# '''

ALPHANUMERIC = r'''(  
						( \d+ \s* / \s* \d+ )   # a fraction
					  | (                       # or number
						  [-+]?                     # sign (maybe)
						  ( \d+ (?!/)               # digits (with no slash)
							[.]?\d* | \.\d+ )       # decimal (maybe)
						  ( [eE] [-+]? \d+ )?       # exponent (maybe)
						)                 
					  | ( [a-zA-Z0-9\-\._]+ )   # or an identifier, filename, even with dashes
					)'''

ALPHANUMERIC_RE =  re.compile( ALPHANUMERIC, re.VERBOSE | re.DOTALL | re.MULTILINE )

# see http://code.google.com/p/networkpx/wiki/PlistSpec#Text        #### in scrapbook
def PL_scan_once( string, index ):
	if index >= len( string ): 
		raise StopIteration
	nextchar = string[ index ]
	if nextchar in QUOTES: 
		obj, index = PListString( string, index + 1 )
		return obj, index
	elif nextchar == '{': 
		obj, index = PListDictionary( string, index + 1 )
		return obj, index
	elif nextchar == '(': 
		obj, index = PListArray( string, index + 1 )
		return obj, index
	elif nextchar == '/': 
		nextchar, index, _ = PListComment( string, index + 1 )
		obj, index = PL_scan_once( string, index )
		return obj, index

	match = ALPHANUMERIC_RE.match( string, index )
	if match is not None: 
		return match.group( 0 ), match.end()
	else: 
		raise MatchFailError( index, string[ index ] )

def PL_scan_name( string, index ):
	if index >= len( string ): 
		raise StopIteration
	nextchar = string[ index ]
	if nextchar in QUOTES:
		obj, index = PListString( string, index + 1 )
		return obj, index
	elif nextchar == '/': 
		nextchar, index, _ = PListComment( string, index + 1 )
		obj, index = PL_scan_name( string, index )
		return obj, index
		
	match = ALPHANUMERIC_RE.match( string, index )
	if match is not None: 
		return match.group( 0 ), match.end()
	else: 
		raise MatchFailError( index, string[ index ] )

	
## .plist file ################################################################


def _find_line_start( plist, index ):
	if len( plist ) == 0: return 0
	return _find_these_chars( plist, index, '\n', -1, skip_content = True )

def _endswith_NL( plist, index = None ):
	if index is None:
		index = len( plist )
	return _find_these_chars( plist, index, '\n', -1, skip_content = False )

def _startswith_NL( plist, index = -1 ):
	return _find_these_chars( plist, index, '\n', 1, skip_content = False )
	
def _find_open_dict( plist, index ):
	return _find_these_chars( plist, index, '{', -1, skip_content = False )

def _find_close_dict( plist, index ):
	return _find_these_chars( plist, index, '}', 1, skip_content = False )
	
def _find_open_list( plist, index = None ):
	if index is None:
		index = len( plist )
	return _find_these_chars( plist, index, '(', -1, skip_content = False )

def _find_close_list( plist, index ):
	return _find_these_chars( plist, index, ')', 1, skip_content = False )

def _find_cmt_prefix( plist, index ):
	line_start = _find_these_chars( plist, index, '\n', -1, skip_content = False )
	if line_start is not None: # nothing but whitespace
		return line_start
	found = _find_these_chars( plist, index, '', -1, skip_content = False )
	return None if found is None else found + 1

def _find_cmt_suffix( plist, index, eol_style = False ):
	if eol_style: # locate eol or bail
		line_end = _find_these_chars( plist, index, '\n', -1, skip_content = False )
		if line_end is not None: # nothing but whitespace
			return line_end
		return index
	# find_close */: preserve trailing whitespace but not eol
	line_end = _find_these_chars( plist, index - 1, '\n', 1, skip_content = False )
	if line_end is not None: # nothing but whitespace
		return line_end
	found = _find_these_chars( plist, index, '', 1, skip_content = False )
	return None if found is None else found - 1

def _find_these_chars( plist, index, chars, direction, skip_content = False ):
	'''Search for any of 'chars' in a (list of) string(s) ('plist') 
	   starting at 'index' stepping in 'direction' (+/-N),
	   perhaps skipping over content. No chars => any non-WS.
	   Return None if fail, index of string in plist
	   that contains a member of 'chars'.'''
	token = None
	try:
		limits = range( index, len( plist ) ) if direction > 0 else range( 0, index ) 
		trim = len( chars ) == 0
		if trim: skip_content = False # both True is nonsense
		offset = index
		while True:
			offset += direction
			if offset not in limits: break # exceeded boundary
			token = plist[ offset ]
			if not isinstance( token, str ): # found a numnber
				if not skip_content: return offset if trim else None
				continue
			if trim: # chars = '' means looking for any visible char
				if token.strip( WHITESPACE_CHAR ) != '': return offset
				continue
			elif skip_content:
				if any( c in chars for c in token ): return offset
				continue
			# search each character
			toklen = len( token )
			idx = toklen if direction < 0 else -direction
			while True:
				idx += direction
				if idx < 0 or idx >= toklen: break # exceeded limit
				tk = token[ idx ]
				if trim and tk not in WHITESPACE_CHAR: return offset # any visible char
				elif tk in chars: return offset
				elif not skip_content and tk not in WHITESPACE_CHAR: 
					return offset if trim else None
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_find_these_chars, index = {}, token = {}'.format( exc, index, token ))
	return None
	
def _process_cmts( ent, start, finis, origID, plist, NL_follows = False ):
	try:
		cmts_to_del = []
		selection = [ cmt for cmt in ent.comments if origID is None or cmt.origID == origID ]
		if len( selection ) > 0:
			comments = [ cmt for cmt in selection if start <= cmt.place <= finis ]
			if len( comments ) > 0:
				comments.sort( key = attrgetter( 'origID', 'place' ) )
				if NL_follows:
					lastc = comments[ -1 ]
					lastt = lastc.text
					lastsNL = _endswith_NL( lastt )
					if lastsNL is not None and ent.place[ ent.output_oi ] <= lastc.place <= ent.lastplace: # only strip internal comments
						comments[ -1 ].text = lastt[ 0:lastsNL  ] # points at NL char
				startsNL = endsNL = False
				for cmt in comments:
					txt = cmt.text
					startsNL = _startswith_NL( txt ) is not None
					if startsNL and ( endsNL or line_empty( plist ) ):
						txt = txt[ 1: ]
					endsNL = _endswith_NL( txt ) is not None
					if endsNL: txt = txt.rstrip( ' \t' )
					if OutputCommentSource and cmt.origID != ent.output_oi:
						plist.extend( [ '\n/* comment included from: ', SourceFileNames[ ent.origin[ cmt.origID ] ], '*/\n' ] )
					plist.append( txt )
					cmts_to_del.append( cmt )
		for cmt in cmts_to_del: # del as output, so ranges can overlap
			ent.comments.remove( cmt )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_process_cmts, ent = {}'.format( exc, ent.name ))
	return plist
	
def _render_values( name, simpleton ):
	ent = Registered_ents[ name ]
	origin = ent.origin
	origID = ent.output_oi
	reported = dict()
	ent_start = ent.place[ origID ]
	plist = _process_cmts( ent, 0, ent_start, None, [], True )
	try:
		plist.extend( [ '\n\t', '"' + ent.name + '"', '=' ] ) # identifiers are always quoted 
		plist = _process_cmts( ent, ent_start, ent_start + len( ent.name ) + 5, None, plist, True ) # 2("")+3( = )
		if not simpleton:
			plist.extend( [ '\n\t', '{' ] )
		order = [ (key, values[ origID ].place, values[ origID ].origID) 
				   for key, values in ent.properties.items() ]
		# - origID's don't always match, as _select_origin modifies values list for missing keys
		order.sort( key = itemgetter( 2, 1 ) ) # sort by origID, place (else comments lose context)
		ordered = list( key for key, _, _ in order )
		for key in ordered:
			values = ent.properties[ key ]
			actual = values[ origID ]
			plist = _process_cmts( ent, ent_start, actual.place, actual.origID, plist, True )
			if actual.origID != origID and actual.name not in Keys_to_rename.values() \
					and actual.name != '<stub>' and actual.name not in Keys_to_insert.values():
				srcFile = EffectsFile if actual.origID is None \
									else SourceFileNames[ origin[ actual.origID ] ]
				if srcFile != EffectsFile:
					if LogDifferentSource:
						_log_warning( '"{}": "{}" defined in both: \n\t{}\n\t{}'.format( 
									actual.name, actual.value, 
									SourceFileNames[ origin[ actual.origID ] ], 
									SourceFileNames[ origin[ origID ] ] ))
					if OutputDifferentSource:
						plist.extend( [ '\n/* ', key, 'defined in: ', srcFile, '*/' ] )
			if not simpleton:
				plist.extend( [ '\n\t\t', key, '=' ] )
			plist = _process_cmts( ent, ent_start, actual.vplace, actual.origID, plist )
			plist.extend( actual.plist )
			plist = _process_cmts( ent, ent_start, actual.vplace + actual.length, actual.origID, plist, True )
			cmpval = ''.join( [ str( token ) for token in actual.plist ] )
			if key not in reported.keys():
				reported[ key ] = [ cmpval ]
			if not OutputDupsAsComments:
				continue
			dups = [ v for v in values if v.value != actual.value ]
			if len( dups ) == 0: # no duplicate definitions 
				continue
			for dup in dups:
				if dup.name == '<stub>': continue # a stub from _select_origin
				if OutputOnlyDifferentDups and _equal_values( actual.value, dup.value ): # dup is same as output
					continue
				cmpval = ''.join( [ str( token ) for token in dup.plist ] )
				if cmpval in reported[ key ] and not OutputDupsSource:
					continue # don't output it twice
				reported[ key ].append( cmpval )
				if OutputDupsSource: # add 2nd comment with filename of duplicate value
					if dup.origID is None:
						source = EffectsFile # data read from effectdata compilation
					else:
						source = SourceFileNames[ origin[ dup.origID ] ]
					plist.extend( [ '\n/* source: ', source, '*/' ] )
				plist.extend( [ '\n/*\t\t', key, '=' ] )
				plist.extend( dup.plist )
				plist.append( '*/' )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_render_values, plist = {}'.format( exc, plist ))
	plist = _process_cmts( ent, ent_start, ent.lastplace, None, plist, True )
	if not simpleton:
		plist.extend( [ '\n\t', '};', '\n\n' ] )
	return _process_cmts( ent, ent_start, 10e10, None, plist, True )

def _select_origin():
	try:
		order = []
		for name, ent in Registered_ents.items():
			origins = ent.origin
			ori_count = len( origins )
			if ori_count == 0 or (len( origins ) == 1 \
							and SourceFileNames[ origins[ 0 ] ].endswith( COLLATE_FN )):  # ent appears only in COLLATE_FN 
			# if ori_count == 0:  # ent appears only in COLLATE_FN 
				order.append([ name, ent.place[ 0 ], 0 ])
				# order.append([ name, ent.place[ 0 ], '' ])
				ent.output_oi = outI = 0
				favoured = sources = [ (0, 0, len( SourceFileNames[ 0 ]), 0) ]
			else:
				sources = [ (origins.index( fn ), fn, len( SourceFileNames[ fn ] )) for fn in origins ]
				sources.sort( key = itemgetter( 2 ) ) # sort by shortest path (arbitrarily)
				if len( Included_dirs ) > 0:
					favoured = [ (idx, fn, ln, Included_dirs.index( incl )) for idx, fn, ln in sources
											   for incl in Included_dirs if incl in SourceFileNames[ fn ] ]
				else: # all folders included
					favoured = [ (idx, fn, ln, 0) for idx, fn, ln in sources ]
				favoured.sort( key = itemgetter( 3, 2 ) ) # by incl (maybe), shortest path 
				order.append([ name, ent.place, favoured[ 0 ][ 1 ] ]) # favoured's first fn
				ent.output_oi = outI = favoured[ 0 ][ 0 ] # favoured's first index
 # IncludeLaunchFolder and 				
			# ensure values have valid id (it won't if missing from one or more sources) and pad for correct length
			for prop, values in ent.properties.items(): 
				while len(values) < ori_count:	# pad to correct len
					values.append( Property( '<stub>', inserted = True ) )
				if values[ outI ].origID == outI:	# they're aligned, we done
					continue
					
				# print(f'"{ent.name}", origins: {origins}, outI is {outI}, values_IDs: {[ v.origID for v in values ]}') 
				# pdb.set_trace()
				
				values_IDs = [ v.origID for v in values ]
				if outI not in values_IDs:		# pick another source
					choices = favoured if any( fav[ 0 ] in values_IDs for fav in favoured ) else sources
					chosen = None
					for dr in choices: # choices is sorted best to worst, so just pick 1st to match
						if dr[ 0 ] in values_IDs: 
							chosen = dr[ 0 ]
							break
					if chosen is None:	chosen = 0	## -1 ?why was that the fallback
					# values[ outI ].origID = 0 if chosen is None else chosen	## -1 ?why was that the fallback
				else:
					chosen = outI
				# an ent's properties is a dict whose values are a list(Property); each of the value's .oridID contains
				#   an index into the ent's .origin (a list of indices into SourceFileNames)
				# the outI'th item in value's list of Property should have .oridID == outI, ie. match ent.output_oi
				# - ent's origin list is static, the outI'th chosen for output.  all value's list[outI] will be 
				#   output too, so ensure the outI'th either matches or is the other choice (above)
				# ent.origin is list of file num's, outI is index into that list
				# target = origins[ outI ]
				# idx = vals_ids.index( outI )
				cag=0
				while values_IDs[ outI ] != chosen:
					values.insert( 0, values.pop() )
					values_IDs = [ v.origID for v in values ]
					cag += 1
					if cag > 10: 
						print('exceeded loop count')
						pdb.set_trace()
					
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_select_origin, order = {}'.format( exc, order ))
	return sorted( order, key = itemgetter( 2, 1 ) ) # group by file, placement (leave ents in original order)

def validate_uniforms():
	try:
		for name, ent in Registered_ents.items():
			propKeys = ent.properties.keys()
			props = []
			if 'materials' in propKeys: props.append( ent.properties[ 'materials' ] )
			if 'shaders' in propKeys: props.append( ent.properties[ 'shaders' ] )
			if len( props ) == 0: continue
			for prop in props: # each a list of Property objects
				for pObj in prop:
					pVal = pObj.value # a dict of dict
					if not isinstance( pVal, dict ): continue
					for encpropKey, shDict in pVal.items():
						if not isinstance( shDict, dict ): continue
						textureFns = []
						uniformRefs = []
						msg = INPUT_FN + ' line '
						noErrLen = len( msg )
						propKey, _ = _decode_placement( encpropKey )
						for encShKey, encShValue in shDict.items():
							shKey, _ = _decode_placement( encShKey )
							shValue, _ = _decode_placement( encShValue )
							if shKey not in ['textures', 'uniforms']:
								continue
							if shKey == 'textures' and isinstance( shValue, list ):
								for sv in shValue:
									decValue, _ = _decode_placement( sv )
									if isinstance( decValue, str ):
										textureFns.append( decValue )
									elif isinstance( decValue, dict ):
										for sk, sv in decValue.items():
											decSubKey, _ = _decode_placement( sk )
											decSubValue, _ = _decode_placement( sv )
											if decSubKey == 'name':
												textureFns.append( decSubValue )
									else:
										raise ValueError('shKey == textures, unknown type {}, for decValue:\n{}'.format( type( decValue ), decValue ))
								textureLen = len( textureFns )
							elif shKey == 'uniforms' and isinstance( shValue, dict ):
								for encUnKey, encUnVal in shValue.items():
									if not isinstance( encUnVal, dict ): continue
									unKey, _ = _decode_placement( encUnKey )
									decUnVal = {}
									for encKey, encVal in encUnVal.items(): # decode dictionary
										decKey, _ = _decode_placement( encKey )
										decVal, _ = _decode_placement( encVal )
										decUnVal[ decKey ] = decVal
									decUnValKeys = decUnVal.keys()
									if 'type' in decUnValKeys and decUnVal[ 'type' ] == 'texture' and 'value' in decUnValKeys:
										textureRef = decUnVal[ 'value' ]
										if not textureRef.isdigit():
											msg += '\n    for key "{}":\n    '.format( name )
											msg += '  Invalid reference value "{}" for uniform of {}'.format(textureRef, propKey)
										else:
											textureRef = int( textureRef )
											uniformRefs.append( textureRef )
							else: # oops
								print('oops!   shKey =', shKey)
								print('oops! shValue =', shValue)
								raise ValueError('unknown key, value pair; encShKey "{}", encShValue:\n{}'.format( encShKey, encShValue  ))

						badrefs = list( ref for ref in uniformRefs if ref >= textureLen )
						if len( badrefs ) > 0:
							print( '! textureLen =', textureLen, 'textureRef =', uniformRefs )
							msg += '\n    for key "{}":\n    '.format( name )
							msg += '  Bad texture reference{} {} for uniform of "{}"'.format(
								   's' if len( badrefs ) > 1 else '', badrefs, propKey )
							msg += '\n        textures list:\n'
							count = 0
							for fn in textureFns:
								msg += '          ' + str( count ) + ': '
								if isinstance( fn, dict ) and 'name' in fn.keys():
									msg += fn[ 'name' ]
								elif isinstance( fn, str ):
									msg += fn
								else:
									msg += 'Unknown file!'
								msg += '\n'
								count += 1
						if len( msg ) > noErrLen:
							_ent_file_msg( ent.origin, name )  # calling for siee
							CurrentFile = SourceFileNames[ ent.origin[ pObj.origID ] ]
							Last_logged_fn = None
							_log_error( msg )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\nvalidate_uniforms, order = {}'.format( exc, order ))

def _gather_comments( outI ):
	comments = []
	try:
		for name, ent in Registered_ents.items():
			del comments[:]
			lastplace = 0
			for cmt in ent.comments:
				if cmt.origID != outI and not ConsolidateComments:
					continue
				cmt.lastplace = cmt.place + len( cmt.text )
				if cmt.lastplace > lastplace: lastplace = cmt.lastplace
				comments.append( cmt )
			for prop in ent.properties.values():
				proplast = 0
				for pr in prop:
					pr.lastplace = pr.place + len( pr.name )  + pr.length
					if pr.lastplace > proplast: proplast = pr.lastplace
					for cmt in pr.comments:
						if cmt.origID != outI and not ConsolidateComments:
							continue
						cmt.lastplace = cmt.place + len( cmt.text )
						if cmt.lastplace > proplast: proplast = cmt.lastplace
						comments.append( cmt )
				if proplast > lastplace: lastplace = proplast
			ent.lastplace = lastplace
		for ent in Registered_ents.values():
			locals = [ cmt for cmt in comments if cmt.place >= ent.place[ cmt.origID ] and cmt.lastplace <= ent.lastplace ]
			ent.comments.extend( [ cmt for cmt in locals if cmt not in ent.comments ] )
			ent.comments.sort( key = attrgetter( 'place' ) )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_gather_comments, comments = {}'.format( exc, comments ))

def _gen_dup_lists( origins ):
	try:
		origins_ents = [ ent for ent in Registered_ents.keys() if Registered_ents[ ent ].origin == origins ]
		dup_props = dict()
		for ent in origins_ents:
			reg_ent = Registered_ents[ ent ]
			props = reg_ent.properties
			if len( reg_ent.origin ) > 1:
				dup_props[ ent ] = []
			for prop, values in props.items():
				if len( values ) <= 1: continue
				if len( [ v for v in values if not v.inserted ] ) <= 1: continue
				if LogOnlyDifferentDups:
					output = values[ reg_ent.output_oi ]
					outstr = _str_minimize( output.value, OpenStep = output.vplace > 0 ) # OpenStep has placement info
					different = False
					for v in values:
						if v.value == output.value: continue
						valstr = _str_minimize( v.value, OpenStep = v.vplace > 0 ) # ==0 means is from XML 
						if valstr == outstr: continue
						different = True
						break
					if not different: continue
				if ent not in dup_props.keys():
					dup_props[ ent ] = []
				origp = prop
				if prop in Keys_to_rename.values():
					origp = [ k for k,v in Keys_to_rename.items() if v == prop ][ 0 ]
				dup_props[ ent ].append( (prop, origp) )
			if LogOnlyDifferentDups and ent in dup_props.keys() and len( dup_props[ ent ] ) == 0:
				del dup_props[ ent ]
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_gen_dup_lists, origins = {}'.format( exc, origins ))
	return dup_props # a dict of lists of tuples,  ent: [(prop,origp),...]

def _gen_log_header( origins, ent, dup_props ):
	try:
		leno = len( origins )
		lend = len( dup_props )
		if leno == 0: # ent only appears in collated file
			if lend > 0 :
				_ent_load_warning( ent )
			return
		if LogOnlyDifferentDups and sum( len( p ) for p in dup_props.values() ) == 0:
			return
		if leno > 1 or lend > 0: # have dups -> output file header
			_ent_file_msg( origins, ent, dup_props )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_gen_log_header, origins = {}\nent = {}, dup_props: {}'.format( exc, origins, ent, dup_props ))
	return dup_props # a dict of lists of tuples,  ent: [(prop,origp),...]
	  
def _simplify_list( lst ):
	if len( lst ) == 0: return ''
	simple = []
	try:
		for item in lst:
			#if COMMENT_MARKER in item: continue # ignore comment
			decit, _ = _decode_placement( item )
			if isinstance( item, list ):
				simple.append( _simplify_list( item ) )
			elif isinstance( item, dict ):
				keys = list( item.keys() )
				if len( keys ) == 1 and COMMENT_MARKER in keys[ 0 ]:
					continue # spec. case of a comment in list 
				simple.append( _simplify_dict( item ) )
			else:
				simple.append( decit )
		simple.sort() # sort for comparison
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_simplify_list, lst is a{}\n{}'.format( exc, type( lst ), lst ))
	return '(' + ', '.join( simple ) + ')'
			 
def _simplify_dict( dct ):
	if len( dct ) == 0: return ''
	simple = []
	try:
		for key, value in dct.items():
			if COMMENT_MARKER in key: continue # ignore comment
			deckey, _ = _decode_placement( key )
			decval, _ = _decode_placement( value )
			if isinstance( value, list ):
				simple.append( [ deckey, _simplify_list( value ) ] )
			elif isinstance( value, dict ):
				simple.append( [ deckey, _simplify_dict( value ) ] )
			else:
				simple.append( [ deckey, decval ] )
		simple = sorted( simple, key = lambda x: str( x[ 0 ] ) + str( x[ 1 ] ) )
		result = '' # sort required so final strings can be compared
		for key, value in simple:
			result += '{} = {};'.format( key, value )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_simplify_dict, dct is a{}\n{}'.format( exc, type( dct ), dct ))
	if result == '': # empty dict from ignored comment(s)
		return ''
	return '{' + result + '}'

def _str_minimize( string, translate = True, OpenStep = False ):
	try:
		if string is None: return ''
		min_str = string
		decstr, _ = _decode_placement( string )
		if isinstance( min_str, list ):
			min_str = _simplify_list( min_str )
		elif isinstance( min_str, dict ):
			min_str = _simplify_dict( min_str )
		# elif isinstance( min_str, bool ):
		elif isinstance( min_str, bool ) or (OpenStep and decstr.lower() in BOOLEANS):
			if OpenStep:
				if decstr in TRUEVALUES:    min_str = 'yes'
				elif decstr in FALSEVALUES: min_str = 'no'
			else:
				min_str = 'yes' if decstr else 'no'
		elif isinstance( decstr, float ) or isinstance( decstr, int ):
			min_str = str( decstr )
		elif decstr.isdigit():
			min_str = str( int( decstr ) )
		elif _is_float( decstr ):
			min_str = str( float( decstr ) )
		elif isinstance( min_str, str ):
			min_str = decstr.strip( QUOTES )
		else:
			raise 'a little hell'
		if isinstance( min_str, str ):
			if translate:
				min_str = min_str.translate( MakeSparse )
			while min_str.find( '  ' ) >= 0:
				min_str = min_str.replace( '  ', ' ' )
			min_str = min_str.strip()
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_str_minimize, min_str is a{}\n{}'.format( exc, type( min_str ), min_str ))
	return min_str

def _equal_values( new, curr ):
	if new == curr: return True
	newx = _str_minimize( new )
	currx = _str_minimize( curr )
	if newx == currx: return True
	return False

def _write_file_marker( file, outI ):
	if OutputSourceAsComment:
		for i in range( len( file ) ):
			src = SourceFileNames[ file[ i ] ]
			_write_eff_data( INPUT_FILE_MARKER.format( ORIGIN_MARKER, src, 
					'  (selected as primary source)' if i == outI and len( file ) > 1 and OutputDupsSource else '' ) ); 
		_write_eff_data( '\n' ); 

def _write_eff_data( out_str ):
	global Output_size
	
	Output_fp.write( out_str )
	Output_size += len( out_str )
	Output_size += out_str.count( '\n' )

	
## main #######################################################################

				   
def _ouput_eff_data():
	try:
		name = item = None # for except print
		if len( Registered_ents ) == 0: return
		input_files = []; 
		ordered = _select_origin()
		if( AuditUniformTextures ): 
			validate_uniforms()
		outI = Registered_ents[ ordered[0][0] ].output_oi
		_gather_comments( outI )
		names = Registered_ents.keys()
		for name, place, file in ordered:
			ent = Registered_ents[ name ]
			simpkeys = ent.properties.keys()
			simpleton = True if len( simpkeys ) == 1 and None in simpkeys else False 
			origin = ent.origin
			if origin not in input_files:
				input_files.append( origin )
				_write_file_marker( origin, outI )
				if LogDuplicateKeys and not simpleton and len( origin ) > 1: # duplicates will exist if existing compilation read
					dup_props = _gen_dup_lists( origin )
					_gen_log_header( origin, name, dup_props )
					if len( dup_props ) > 0:
						_ent_dup_error( dup_props )
			if COMMENT_MARKER in name: # it's a comment ent
				tokens = []
				for cmt in ent.comments:
					tokens.append( cmt.text )
			else:
				tokens = _render_values( name, simpleton )
			output = ''
			count = len( tokens )
			lastout_ws = False
			for num in range( count ): # format tokens with 'smart' spacing
				item = tokens[ num ]
				if item == '': continue
				if not isinstance( item, str ): # int or float
					skip_blank = lastout_ws
					append_blank = False
				else:
					firstc, lastc = item[ 0 ], item[ -1 ]
					nextt = None if num + 1 >= count else tokens[ num + 1 ] 
					# skip_blank = lastout_ws or line_empty( output, '{(' ) or firstc in (WHITESPACE_CHAR + '({,;/')
					skip_blank = lastout_ws or firstc in (WHITESPACE_CHAR + ',;/') #'({,;/')
					if nextt is None:
						append_blank = False
					elif not isinstance( nextt, str ): # int or float
						append_blank = True
					else:
						append_blank = lastc in ',;=' and nextt and nextt[ 0 ] in '(){}'
				output += '{}{}{}'.format( '' if skip_blank else ' ', 
									item, ' ' if append_blank else '' )
				lastout_ws = append_blank or output[ -1 ] in WHITESPACE_CHAR
			_write_eff_data( output.replace( '\t', ' ' * TABSPACE ) )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			print( '{}\n_ouput_eff_data, name = {}, item = {}'.format( exc, name, item ))

def nextVersion( fn, ext ):
	def fmtVernFn( num ):
		return '{}{}{}'.format( fn, '.{}'.format( num ) if num > 0 else '', ext )
		
	versToIncr = []
	for vern in range( 0, MaxVersions ):
		currFn = os.path.join( Launch_dir, fmtVernFn(vern) )
		if os.path.exists( currFn ):
			versToIncr.append( (vern, currFn) )
		else:	# leave older versions alone
			break
	for vern, currFn in reversed( versToIncr ):
		nextFn = os.path.join( Launch_dir, fmtVernFn(vern + 1) )
		if vern + 1 == MaxVersions and os.path.exists( nextFn ):
			os.remove( nextFn )
		os.rename( currFn, nextFn )
		# os.replace( currFn, nextFn ) # Python3 only
	return fmtVernFn( 0 )			# convenience return

def _update_eff_data():
	global CurrentFile, EntsInEffectsdata, Output_fp, Loading_data, EffectsFile
	
	Loading_data = err = False 
	CurrentFile = fp = None
	try:
		if COLLATE_FN is not None: # else run for side effects os.path.dirname(Launch_dir) 
			file = os.path.join( Launch_dir, COLLATE_FN )
			if os.path.exists( file ): # IncludeLaunchFolder and 
				# first, read in collated file to build up Registered_ents
				Loading_data = True
				EffectsFile = CurrentFile = file
				with open( file, mode = 'r' ) as fp:
				# with open( file, mode = 'r', encoding = 'utf-8' ) as fp:
					Logfile.write( '-> loading existing plist compilation file {}\n'.format( file ) )
					err = _load_effects( fp, file )
					EntsInEffectsdata = len( Registered_ents )
					Logfile.write( '   done ({:,}), Registered_ents has {}\n\n'.format( Existing_size, EntsInEffectsdata ) )
					
				# if Launch_folder not in Included_dirs:		## only to regen bug ?fixed by rewrite of _select_origin
					# Included_dirs.append(Launch_folder)
					
			nextVersion( COLLATE_FILE, COLLATE_EXT )	# rename any existing versions
			Output_fp = open( file, mode = 'w' )
			# Output_fp = open( file, mode = 'w', encoding = 'utf-8' )
			_write_eff_data( OUTPUT_FILE_HEADER );
			fp = 'done'
			Loading_data = False
			CurrentFile = None
		
		err = _proc_dir( [ Launch_dir ] ) or err # recurse folder tree proc'g any shipdata.plist files
		_log_blankline()
		print('')
		
		if( COLLATE_FN is not None ): # else run for side effects
			_ouput_eff_data()
			_write_eff_data( TELESCOPE_EFFECTDATA );
			_write_eff_data( OUTPUT_FILE_TAIL )
	except IOError as msg:
		err = True
		print( '_update_eff_data, launched in {}, cwd = {}, isdir = {}'.format( 
								  Launch_dir, os.getcwd(), None if pfiles is None else os.path.isdir( pfiles ) ) )
		sys.stderr.write( 'Cannot open: {}\n'.format( msg ) )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
		else:
			fp_result =  'loaded' if fp == 'done' else 'failed' if fp is not None and Loading_data else 'not found?'
			print( '{}\n_update_eff_data, CurrentFile = {}, DB {}, err = {}'.format( exc, CurrentFile, fp_result, err ) )
	finally:
		if( COLLATE_FN is not None ): # else run for side effects
			Output_fp.close()
	if err: 
		print( 'check log file for errors' )
	return err

if __name__ == "__main__":
	err = True
	print('argv: {}'.format(sys.argv))
	try:
		Launch_dir = os.getcwd()
		Launch_folder = os.path.basename( Launch_dir )
		Included_dirs = INCLUDE_FOLDERS[:]
		if Python2:
			Logfile = open( os.path.join( Launch_dir, LOG_FN ), mode = 'w' )
		else:
			Logfile = open( os.path.join( Launch_dir, LOG_FN ), mode = 'w', encoding = 'utf-8' )
		
		err = _update_eff_data()
		
		existing = EntsInEffectsdata > 0
		new_ents = len( Registered_ents ) - EntsInEffectsdata
		Logfile.write( '\nExisting file {}, processed {} files, new entities registered: {}{}'.format( 
		   'had {}'.format( EntsInEffectsdata ) if existing else 'was not found',
		   Input_file_count, new_ents, 
		   ', total of {}.'.format( EntsInEffectsdata + new_ents ) if existing else '' ) )
		num_reg = len( Registered_ents )
		if num_reg != EntsInEffectsdata + new_ents:
			Logfile.write( '\nError: size of Registered_ents ({}) not equal to '.format( num_reg ) )
			Logfile.write( 'EntsInEffectsdata ({}) + ({}) new_ents'.format( EntsInEffectsdata, new_ents ) )
												
		Logfile.write( '\n\n  input:{}existing {:>11,}\n'.format( ' '*4, Existing_size ) )
		Logfile.write( '{}shipdata {:>11,}\n'.format( ' '*12, Input_size ) )
		Logfile.write( '{}total {:>14,}\n'.format( ' '*12, (Existing_size + Input_size) ) )
									
		static = len( TELESCOPE_EFFECTDATA )
		generated = Output_size - static
		Logfile.write( '\n output:{}static {:>13,}\n'.format( ' '*4, static ) )
		Logfile.write( '{}generated {:>10,}\n'.format( ' '*12, generated ) )
		Logfile.write( '{}total {:>14,}\n'.format( ' '*12, Output_size ) )
		
		print( 'Collected data from {} files, output is {}'.format( Input_file_count, Output_size ) )
	except Exception as exc:
		if DEBUG:
			stackprinter.show(exc, suppressed_paths=[r'D:\\Python36\\*'])
			pdb.set_trace()
	finally:
		if Logfile is not None: Logfile.close()

	try:
		input( '\nDetails are in log file.\nHit any key to close window.' )
	except:
		pass
	if err:
		sys.exit( 1 )
		
